
set xact_abort on
BEGIN TRAN
--  
--   
USE [{Variable_TempDb}]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__GROUP_ACTIVE_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__GROUP_ACTIVE_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT,
  VARCHAR(5))
ELSE 
	DELETE FROM [dbo].[__GROUP_ACTIVE_SMETA_KS]

USE [{Variable_TempDb}]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].GROUP_ACTIVE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT_OS INT, @iOBJECT_MZ INT

SELECT @iOBJECT_OS = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'INVENTORY_CARD'

SELECT @iOBJECT_MZ = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'NOMENCLATURE_MAT_CEN'

SELECT ACCOUNT_B 
INTO #GROUP_ACTIVE_ACCOUNTS
FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE

INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE
	(CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED, LINK_SELF,
	CODE_PRF, [OBJECT],LINK_DEP,[LINK_OLD])
OUTPUT INSERTED.link,INSERTED.[LINK_OLD],INSERTED.CODE_GRP
	INTO [{Variable_TempDb}].dbo.[__GROUP_ACTIVE_SMETA_KS]
SELECT DISTINCT
    CODE_GRP    = RIGHT(LTRIM(RTRIM(gi.CODE)),5),
    [NAME]      = LTRIM(RTRIM(gi.NAME)),
    ACCOUNT_B   = ssa.LINK, 
    [SYSTEM]    = gi.[SYSTEM], 
    [TYPE]      = gi.[TYPE], 
    ACCOUNT_AM  = ssa2.LINK,
    ISUSED      = gi.ISUSED,
    LINK_SELF   = NULL,
    CODE_PRF    = NULL ,
    [OBJECT]    = CASE WHEN LEFT(REPLACE(gi.CODE {WORK_COLLATE},'.',''),3) = '105' THEN @iOBJECT_MZ ELSE @iOBJECT_OS END ,
    LINK_DEP    = {LINK_DEP_MAIN},
    [LINK_OLD]  = gi.LINK
FROM 
	{Variable_SmetaDb}.dbo.GROUP_INV gi
	LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa ON sa.LINK = gi.ACCOUNT
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS ssa ON ssa.CODE = sa.CODE {WORK_COLLATE} AND ssa.LINK_DEP = {LINK_DEP_MAIN}

	LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa2 ON sa2.LINK = gi.ACCOUNT_AM
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS ssa2 ON ssa2.CODE = sa2.CODE {WORK_COLLATE} AND ssa2.LINK_DEP = {LINK_DEP_MAIN}
WHERE 
	ssa.LINK NOT IN (SELECT ACCOUNT_B FROM #GROUP_ACTIVE_ACCOUNTS)

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_GROUP_ACTIVE_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_GROUP_ACTIVE_SMETA_KS]

SELECT
	             = isnull(gi.CODE,''), 
	    = isnull(gi.NAME,''),
	        = ssa.CODE,
	         = '         '
INTO [{Variable_TempDb}].dbo.[__JOURNAL_GROUP_ACTIVE_SMETA_KS]
FROM {Variable_SmetaDb}.dbo.GROUP_INV gi
	LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa ON sa.LINK = gi.ACCOUNT
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS ssa ON ssa.CODE = sa.CODE {WORK_COLLATE} AND ssa.LINK_DEP = {LINK_DEP_MAIN}
WHERE ssa.LINK IN (SELECT ACCOUNT_B FROM #GROUP_ACTIVE_ACCOUNTS)
ORDER BY 

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_GROUP_ACTIVE_SMETA_KS', ISNULL(@iROWS_NOT_COPIED,0))
--

DROP TABLE #GROUP_ACTIVE_ACCOUNTS

ALTER TABLE [{Variable_WorkDb}].[dbo].GROUP_ACTIVE DROP COLUMN [LINK_OLD]
GO

-- !!!       
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH

COMMIT TRAN

