
set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO


DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

CREATE TABLE #CODE (OLD_CODE VARCHAR(10), NEW_CODE VARCHAR(10), KBK_TYPE INT)
GO
INSERT #CODE VALUES ('101.05', '101.35', NULL)
INSERT #CODE VALUES ('101.02', '101.12', NULL)
INSERT #CODE VALUES ('104.01', '104.11', NULL)
INSERT #CODE VALUES ('101.06', '101.36', NULL)
INSERT #CODE VALUES ('104.04', '104.34', NULL)
INSERT #CODE VALUES ('105.06', '105.36', NULL)
INSERT #CODE VALUES ('104.02', '104.12', NULL)
INSERT #CODE VALUES ('104.05', '104.35', NULL)
INSERT #CODE VALUES ('104.06', '104.36', NULL)
INSERT #CODE VALUES ('106.01', '106.31', NULL)
INSERT #CODE VALUES ('101.04', '101.34', NULL)
INSERT #CODE VALUES ('401.01', '401.20', 1)
INSERT #CODE VALUES ('401.01', '401.10', 2)
GO


DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

DECLARE @LINK_TITLE INT
SET @LINK_TITLE = (Select TOP 1 link from {Variable_SmetaDb}.dbo.s_property where code {WORK_COLLATE} = 'TITLE')

SELECT
	ROW_ID = ROW_NUMBER() OVER (ORDER BY T.LINK_NEW),
	VD.LINK_CB,
	GP.link,
	[NAME] = convert(varchar(254), OV.VALUE),
	gp.number,
	[DATE] = convert(datetime, gp.[date], 104),
	[DATE_PROV] = convert(datetime, gp.date_prov, 104), 
	GP2.SUMMA,
	[INV] = T.LINK_NEW,
	[ACC_DT] = sa12.link,
	[ACC_KT] = sa22.link,
	[EMPL] = T2.LINK_NEW,
	GP.[COMMENT]
INTO #DATA	
FROM 
	{Variable_SmetaDb}.dbo.G_PROV GP
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = GP.DEP
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = dsks.LINK_NEW
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO ON (SO.CODE <> 'SHABLON_DOCUMENTS_PROV' AND SO.LINK = GP.[OBJECT])
		LEFT JOIN {Variable_SmetaDb}.dbo.Object_Values OV ON OV.[OBJECT] = SO.LINK AND OV.PROPERTY = @LINK_TITLE
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 GP1 ON  (GP1.LINK_UP = GP.LINK)
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV2 GP2 ON  (GP2.LINK_UP = GP1.LINK)
	INNER JOIN {Variable_SmetaDb}.dbo.g_prov_ap gap_d ON gap_d.LINK_UP = GP2.LINK and gap_d.DB_KR = 0
	INNER JOIN {Variable_SmetaDb}.dbo.g_prov_ap gap_K ON gap_K.LINK_UP = GP2.LINK and gap_K.DB_KR = 1	
	INNER JOIN {Variable_TempDb}.[dbo].[__INVENTORY_SMETA_KS] T ON T.LINK_OLD = ISNULL(gap_d.INV,gap_K.INV)
	INNER JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa11 ON sa11.LINK = gap_d.ACCOUNT	
	INNER JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa21 ON sa21.LINK = gap_K.ACCOUNT	
	LEFT JOIN {Variable_TempDb}.dbo.[__EMPL_SMETA_KS] T2 ON T2.LINK_OLD = (CASE WHEN GAP_D.ACCOUNT = GAP_K.ACCOUNT THEN gap_K.EMP ELSE gap_D.EMP END)

	LEFT JOIN {Variable_SmetaDb}.dbo.KL_KBK K1 ON K1.LINK = gap_d.KBK
	LEFT JOIN {Variable_SmetaDb}.dbo.KL_KBK K2 ON K2.LINK = gap_K.KBK	

	LEFT JOIN #CODE C1 ON C1.OLD_CODE = sa11.cSinth + '.' + sa11.cAnalit {WORK_COLLATE} AND (C1.KBK_TYPE IS NULL OR C1.KBK_TYPE = (K1.[TYPE] & 3) )
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS sa12 ON sa12.cSource = sa11.cSource {WORK_COLLATE}  
								AND ISNULL(C1.NEW_CODE, (sa11.cSinth + '.' + sa11.cAnalit)) = sa12.cSinth + '.' + sa12.cAnalit {WORK_COLLATE} 
								AND sa12.LINK_DEP = VD.LINK_CB
			
	
	LEFT JOIN #CODE C2 ON C2.OLD_CODE = sa21.cSinth + '.' + sa21.cAnalit {WORK_COLLATE} AND (C2.KBK_TYPE IS NULL OR C2.KBK_TYPE = (K2.[TYPE] & 3) )
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS sa22 ON sa22.cSource = sa21.cSource {WORK_COLLATE}
									AND ISNULL(C2.NEW_CODE, (sa21.cSinth + '.' + sa21.cAnalit)) = sa22.cSinth + '.' + sa22.cAnalit {WORK_COLLATE} 
									AND sa22.LINK_DEP = VD.LINK_CB

WHERE
	GP.DATE_PROV IS NOT NULL AND GP.DATE_PROV < @dDATE	
	AND
	GP2.ECON_OPER IS NOT NULL
GO

USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__VIBOR_ECON_OPER]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__VIBOR_ECON_OPER] (
	[ACC_DT] INT,
	[ACC_KT] INT,
	[DEP] INT,
	[ECON_OPER] INT)
	
ELSE 
	DELETE FROM [dbo].[__VIBOR_ECON_OPER]
	GO


IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER1')
CREATE INDEX [IX__VIBOR_ECON_OPER1] ON [dbo].[__VIBOR_ECON_OPER] (ACC_DT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER2')
CREATE INDEX [IX__VIBOR_ECON_OPER2] ON [dbo].[__VIBOR_ECON_OPER] (ACC_KT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER3')
CREATE INDEX [IX__VIBOR_ECON_OPER3] ON [dbo].[__VIBOR_ECON_OPER] (DEP)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER4')
CREATE INDEX [IX__VIBOR_ECON_OPER4] ON [dbo].[__VIBOR_ECON_OPER] (ECON_OPER)-- ON [INDEX]
GO


-- 
INSERT INTO {Variable_TempDb}.[dbo].[__VIBOR_ECON_OPER] ([ACC_DT], [ACC_KT], [DEP])
SELECT DISTINCT [ACC_DT], [ACC_KT], [LINK_CB]
FROM #DATA
GO

UPDATE {Variable_TempDb}.[dbo].[__VIBOR_ECON_OPER]
SET [ECON_OPER] = (SELECT TOP 1 LINK FROM {Variable_WorkDb}.dbo.BX_BPROV_VIBOR_ECON_OPER([ACC_DT], [ACC_KT], DEFAULT, [DEP]))
GO


USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__INVENTORY_HIS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__INVENTORY_HIS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__INVENTORY_HIS]
	
GO


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].[INVENTORY_HIS]'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].[INVENTORY_HIS] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE {Variable_WorkDb}.[dbo].[INVENTORY_HIS] ADD [LINK_OLD] INT NULL
GO


USE {Variable_TempDb}
GO

INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS (LINK_UP, NUMBER, NAME, DATE, DATE_PROV,SUMMA,COMMENT,HOZ_OPER, LINK_OLD)
OUTPUT inserted.LINK, inserted.LINK_OLD INTO {Variable_TempDb}.[dbo].[__INVENTORY_HIS] ([LINK_NEW],[LINK_OLD])
SELECT
	T3.[INV], T3.NUMBER, T3.[NAME], T3.[DATE], T3.[DATE_PROV], T3.SUMMA, T3.COMMENT, EO.ECON_OPER, T3.ROW_ID 
FROM
	#DATA T3 
	INNER JOIN {Variable_TempDb}.[dbo].[__VIBOR_ECON_OPER] EO ON EO.[ACC_DT] = T3.[ACC_DT] AND EO.[ACC_KT] = T3.[ACC_KT]


INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS_DETAILS (LINK_UP,NAME,VALUE)
SELECT T.LINK_NEW, '', E.NAME_EMPL
FROM
	{Variable_TempDb}.[dbo].[__INVENTORY_HIS] T
	INNER JOIN #DATA T3 ON T3.ROW_ID = T.LINK_OLD
	INNER JOIN {Variable_TempDb}.[dbo].[__VIBOR_ECON_OPER] EO ON EO.[ACC_DT] = T3.[ACC_DT] AND EO.[ACC_KT] = T3.[ACC_KT]
	INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_VIEW XO ON XO.LINK = EO.ECON_OPER
	INNER JOIN {Variable_WorkDb}.dbo.V_EMPL E ON E.LINK = T3.[EMPL]
WHERE
	EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.V_INVENTORY_ACTION A WHERE A.NAME = '' AND A.HO LIKE '%' + XO.FULLCODE {WORK_COLLATE} + '%')
GO

ALTER TABLE {Variable_WorkDb}.[dbo].[INVENTORY_HIS] DROP COLUMN [LINK_OLD]
GO


COMMIT TRAN
GO
