
-- -
-- 
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'DOC_INVOICE_ISSUED'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = '20010101' -- DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    	
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'DOCUMENTS_INVOICE_ISSUED'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[INVOICE_ISSUED] 
	(LINK_UP,CONS1_SELF,CONS1_LINK,PROD_LINK,CONS2_SELF,CONS2_LINK,PAYS_LINK,NUM_BASE,DATE_BASE,BOOK_SALES,
	OSNOV,TAX_RATE,NALOG_DOC,COR_NUM,COR_DATE,TYPE_BOOK,BIL_DATE,AVANSE,NUM_BASE_LINK,PROV_SUM_NO_NDS,PROV_NDS,PR_DOC_R_S,DOC_OSN_NAME,DOC_OSN_NUM)

SELECT 
	[LINK_UP] = C.LINK_NEW
	,[CONS1_SELF] = CASE WHEN SHIPPER.LINK_NEW IS NULL THEN 0 ELSE 1 END --  - 
	,[CONS1_LINK] = SHIPPER.LINK_NEW --  --
	,[PROD_LINK] = SELLER.LINK_NEW --  --
	,[CONS2_SELF] = CASE WHEN RECEIVER.LINK_NEW IS NULL THEN 0 ELSE 1 END --  - 
	,[CONS2_LINK] = RECEIVER.LINK_NEW --  --
	,[PAYS_LINK] = BUYER.LINK_NEW
	,[NUM_BASE] = I.[PAY_NUM]
	,[DATE_BASE] = I.[PAY_DATE]
	,[BOOK_SALES] = I.[INBOOK]
	,[OSNOV] = gpsks.LINK_NEW
	,[TAX_RATE] = I.[TAX_RATE]
	,[NALOG_DOC] = I.[TAX_SUM]
	,[COR_NUM] = I.[COR_NUM]
	,[COR_DATE] = I.[COR_DATE]
	,[TYPE_BOOK] = NULL 
	,[BIL_DATE] = I.[BIL_DATE]
	,[AVANSE] = NULL 
	,[NUM_BASE_LINK] = NULL 
	,[PROV_SUM_NO_NDS] = NULL 
	,[PROV_NDS] = NULL 
	,[PR_DOC_R_S] = NULL 
	,[DOC_OSN_NAME] = NULL 
	,[DOC_OSN_NUM] = NULL
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] C
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_INVOICE I ON I.[DOC_LINK] = C.LINK_OLD
	LEFT JOIN {Variable_SmetaDb}.dbo.OSNOV o ON o.LINK = I.[OSNOV]
	LEFT JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS) gpsks ON gpsks.LINK_OLD = o.LINK_G_PROV AND gpsks.RowNumber = 1
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SELLER ON SELLER.LINK_OLD = I.SELLER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = I.BUYER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SHIPPER ON SHIPPER.LINK_OLD = I.SHIPPER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] RECEIVER ON RECEIVER.LINK_OLD = I.RECEIVER -- 
WHERE 
	C.[DATE] = @DATE_CONV   

---    
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOCBASE ([LINK_UP],[DOCBASE_NUM],[DOCBASE_DATE],[DOC_ANALIT],[NOT_PRINT],[COMMENT],[DOCBASE_NAME],[DOCBASE_LINK],[FIRST_DOC])
SELECT
	[LINK_UP] = A.LINK_UP
	,[DOCBASE_NUM]  = G.NUMBER
	,[DOCBASE_DATE] = G.[DATE]
	,[DOC_ANALIT]  = 1
	,[NOT_PRINT] = 0
	,[COMMENT] = ''
	,[DOCBASE_NAME] = SO.NAME
	,[DOCBASE_LINK] = G.LINK
	,[FIRST_DOC] = 1
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] C
	INNER JOIN [{Variable_WorkDb}].[dbo].[INVOICE_ISSUED] A ON A.LINK_UP = C.LINK_NEW
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.OSNOV = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.S_OBJECTS SO ON SO.LINK = G.[OBJECT]
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_DOCBASE T1 WHERE T1.LINK_UP = A.LINK_UP AND T1.[DOCBASE_LINK] = G.LINK)	 

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
SELECT 
	LINK_UP         = C.LINK_NEW, 
	SUPPLIER_LINK   = SELLER.LINK_NEW,
	BUYER_LINK      = BUYER.LINK_NEW
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] C
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_INVOICE I ON I.[DOC_LINK] = C.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SELLER ON SELLER.LINK_OLD = I.SELLER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = I.BUYER -- 
WHERE 
	C.[DATE] = @DATE_CONV	

---   
DECLARE @iREALIS_OPER INT, @iAVANCE_OPER INT
SELECT TOP 1 @iREALIS_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_ISSUED_SELLING' --''
SELECT TOP 1 @iAVANCE_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_ISSUED_IMPREST' --''

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT
	LINK_UP     = C.LINK_NEW,
	DOC_OPER   = @iREALIS_OPER
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] C
WHERE 
	C.[DATE] = @DATE_CONV	

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


DECLARE
	@iLINK INT
	,@iLINK_UP		INT
	,@iINV_TYPE		TINYINT
	,@iINV_LINK		INT
	,@nPRICE		NUMERIC(19, 4)
	,@nAKCIZ		NUMERIC (19, 4)
	,@cNUM_TD		VARCHAR(30)
	,@nQTY			NUMERIC(19, 4)
	,@nSUMMA		NUMERIC(19, 4)
	,@nSTAVKA_NDS	NUMERIC(18, 2)
	,@nSUMMA_NDS	NUMERIC(19, 4)
	,@nSUMMA_ALL	NUMERIC(19, 4)
	,@iNO_NDS		TINYINT
	
DECLARE CURS CURSOR SCROLL FOR 

SELECT 
	C.LINK_NEW, 
	INV_TYPE = CASE B.INV_TYPE {WORK_COLLATE} WHEN 'INVENTORY_CARD' THEN 1 WHEN 'DICTIONARY_TMC' THEN 2 WHEN 'DICTIONARY_SERV' THEN 4 WHEN 'BV_NOMENCLATURE' THEN 2 END,
	iINV_LINK = COALESCE(I.LINK_NEW,TMC.LINK_NEW,N.LINK_NEW),
	B.PRICE,
	B.AKCIZ,
	B.NUM_TD, 
	B.QTY,
	B.SUMMA,
	B.STAVKA_NDS,
	B.SUMMA_NDS,
	B.SUMMA_ALL,
	B.NO_NDS
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] C
	INNER JOIN {Variable_SmetaDb}.dbo.conv_BK_DOC_TABLE_MZ_NDS_FN B ON B.[LINK_UP] = C.[LINK_OLD]
	LEFT JOIN [{Variable_TempDb}].dbo.__DICTIONARY_TMC_SMETA_KS TMC ON B.INV_TYPE {WORK_COLLATE} = 'DICTIONARY_TMC' AND B.INV_LINK = TMC.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.__INVENTORY_SMETA_KS I ON B.INV_TYPE {WORK_COLLATE} = 'INVENTORY_CARD' AND B.INV_LINK = I.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_SMETA_KS N ON (B.INV_TYPE {WORK_COLLATE} = 'BV_NOMENCLATURE' OR B.INV_TYPE {WORK_COLLATE} = 'DICTIONARY_SERV') AND B.INV_LINK = N.LINK_OLD	
WHERE 
	C.[DATE] = @DATE_CONV	


OPEN CURS
FETCH FIRST FROM CURS INTO @iLINK_UP, @iINV_TYPE, @iINV_LINK, @nPRICE, @nAKCIZ, @cNUM_TD, @nQTY, @nSUMMA, @nSTAVKA_NDS, @nSUMMA_NDS, @nSUMMA_ALL, @iNO_NDS
WHILE @@FETCH_STATUS=0
BEGIN
    IF @@FETCH_STATUS=0
    BEGIN

        SET @iLINK=0
        EXEC [{Variable_WorkDb}].dbo.X_SAVE_DOC_TABLE_MZ_NDS
            @iLINK            
            ,@iLINK_UP          = @iLINK_UP
            ,@iORDERS           = 0
            ,@iINV_TYPE         = @iINV_TYPE
            ,@iINV_LINK         = @iINV_LINK
            ,@nPRICE            = @nPRICE
            ,@nAKCIZ            = @nAKCIZ
            ,@iCOUNTRY_LINK     = NULL
            ,@cNUM_TD           = @cNUM_TD
            ,@nQTY              = @nQTY
            ,@nSUMMA            = @nSUMMA
            ,@nSTAVKA_NDS       = @nSTAVKA_NDS
            ,@nSUMMA_NDS        = @nSUMMA_NDS
            ,@nSUMMA_ALL        = @nSUMMA_ALL
            ,@iEKR              = NULL
            ,@iFIN_SOURCE       = NULL
            ,@iNO_NDS           = @iNO_NDS
            ,@iTYPE_NDS_LINK    = NULL
            ,@iDOP_CLASSIF_LINK = NULL
            ,@iKAU_LINK         = NULL
            ,@iKL_KBK_LINK      = NULL
            ,@iKL_REG_LINK      = NULL
            ,@nSTAVKA_NDS_AVANSE= 0

			SELECT @iError = @@ERROR
			IF @iError <> 0
			BEGIN
				ROLLBACK
			END

        FETCH NEXT FROM CURS INTO @iLINK_UP, @iINV_TYPE, @iINV_LINK, @nPRICE, @nAKCIZ, @cNUM_TD, @nQTY, @nSUMMA, @nSTAVKA_NDS, @nSUMMA_NDS, @nSUMMA_ALL, @iNO_NDS
    END
END
CLOSE CURS
DEALLOCATE CURS

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "- "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

GO


GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO

-- -
-- 
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'DOC_INVOICE_RECEIVED'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = '20010101' --DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    	
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC,LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'DOCUMENTS_INVOICE_RECEIVED'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[INVOICE_ISSUED] 
	(LINK_UP,CONS1_SELF,CONS1_LINK,PROD_LINK,CONS2_SELF,CONS2_LINK,PAYS_LINK,NUM_BASE,DATE_BASE,BOOK_SALES,
	OSNOV,TAX_RATE,NALOG_DOC,COR_NUM,COR_DATE,TYPE_BOOK,BIL_DATE,AVANSE,NUM_BASE_LINK,PROV_SUM_NO_NDS,PROV_NDS,PR_DOC_R_S,DOC_OSN_NAME,DOC_OSN_NUM)

SELECT 
	[LINK_UP] = C.LINK_NEW
	,[CONS1_SELF] = CASE WHEN SHIPPER.LINK_NEW IS NULL THEN 0 ELSE 1 END --  - 
	,[CONS1_LINK] = SHIPPER.LINK_NEW --  --
	,[PROD_LINK] = SELLER.LINK_NEW --  --
	,[CONS2_SELF] = CASE WHEN RECEIVER.LINK_NEW IS NULL THEN 0 ELSE 1 END --  - 
	,[CONS2_LINK] = RECEIVER.LINK_NEW --  --
	,[PAYS_LINK] = BUYER.LINK_NEW
	,[NUM_BASE] = I.[PAY_NUM]
	,[DATE_BASE] = I.[PAY_DATE]
	,[BOOK_SALES] = I.[INBOOK]
	,[OSNOV] = gpsks.LINK_NEW
	,[TAX_RATE] = I.[TAX_RATE]
	,[NALOG_DOC] = I.[TAX_SUM]
	,[COR_NUM] = I.[COR_NUM]
	,[COR_DATE] = I.[COR_DATE]
	,[TYPE_BOOK] = NULL 
	,[BIL_DATE] = I.[BIL_DATE]
	,[AVANSE] = NULL 
	,[NUM_BASE_LINK] = NULL 
	,[PROV_SUM_NO_NDS] = NULL 
	,[PROV_NDS] = NULL 
	,[PR_DOC_R_S] = NULL 
	,[DOC_OSN_NAME] = NULL 
	,[DOC_OSN_NUM] = NULL
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] C
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_INVOICE I ON I.[DOC_LINK] = C.LINK_OLD
	LEFT JOIN {Variable_SmetaDb}.dbo.OSNOV o ON o.LINK = I.[OSNOV]
	LEFT JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS) gpsks ON gpsks.LINK_OLD = o.LINK_G_PROV AND gpsks.RowNumber = 1
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SELLER ON SELLER.LINK_OLD = I.SELLER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = I.BUYER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SHIPPER ON SHIPPER.LINK_OLD = I.SHIPPER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] RECEIVER ON RECEIVER.LINK_OLD = I.RECEIVER -- 
WHERE 
	C.[DATE] = @DATE_CONV

---    
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOCBASE ([LINK_UP],[DOCBASE_NUM],[DOCBASE_DATE],[DOC_ANALIT],[NOT_PRINT],[COMMENT],[DOCBASE_NAME],[DOCBASE_LINK],[FIRST_DOC])
SELECT
	[LINK_UP] = A.LINK_UP
	,[DOCBASE_NUM]  = G.NUMBER
	,[DOCBASE_DATE] = G.[DATE]
	,[DOC_ANALIT]  = 1
	,[NOT_PRINT] = 0
	,[COMMENT] = ''
	,[DOCBASE_NAME] = SO.NAME
	,[DOCBASE_LINK] = G.LINK
	,[FIRST_DOC] = 1
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] C
	INNER JOIN [{Variable_WorkDb}].[dbo].[INVOICE_ISSUED] A ON A.LINK_UP = C.LINK_NEW
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.OSNOV = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.S_OBJECTS SO ON SO.LINK = G.[OBJECT]
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_DOCBASE T1 WHERE T1.LINK_UP = A.LINK_UP AND T1.[DOCBASE_LINK] = G.LINK)	 
	

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
SELECT 
	LINK_UP         = C.LINK_NEW, 
	SUPPLIER_LINK   = SELLER.LINK_NEW,
	BUYER_LINK      = BUYER.LINK_NEW
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] C
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_INVOICE I ON I.[DOC_LINK] = C.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] SELLER ON SELLER.LINK_OLD = I.SELLER -- 
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = I.BUYER -- 
WHERE 
	C.[DATE] = @DATE_CONV	

---   
DECLARE @iREALIS_OPER INT, @iAVANCE_OPER INT
SELECT TOP 1 @iREALIS_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_RECEIVED_RECEIPT' -- 
SELECT TOP 1 @iAVANCE_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_RECEIVED_IMPREST' -- 

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT
	LINK_UP     = C.LINK_NEW,
	DOC_OPER   = @iREALIS_OPER
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] C
WHERE 
	C.[DATE] = @DATE_CONV	


---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


DECLARE
	@iLINK INT
	,@iLINK_UP		INT
	,@iINV_TYPE		TINYINT
	,@iINV_LINK		INT
	,@nPRICE		NUMERIC(19, 4)
	,@nAKCIZ		NUMERIC (19, 4)
	,@cNUM_TD		VARCHAR(30)
	,@nQTY			NUMERIC(19, 4)
	,@nSUMMA		NUMERIC(19, 4)
	,@nSTAVKA_NDS	NUMERIC(18, 2)
	,@nSUMMA_NDS	NUMERIC(19, 4)
	,@nSUMMA_ALL	NUMERIC(19, 4)
	,@iNO_NDS		TINYINT
	
DECLARE CURS CURSOR SCROLL FOR 

SELECT 
	C.LINK_NEW, 
	INV_TYPE = CASE B.INV_TYPE {WORK_COLLATE} WHEN 'INVENTORY_CARD' THEN 1 WHEN 'DICTIONARY_TMC' THEN 2 WHEN 'DICTIONARY_SERV' THEN 4 WHEN 'BV_NOMENCLATURE' THEN 2 END,
	iINV_LINK = COALESCE(I.LINK_NEW,TMC.LINK_NEW,N.LINK_NEW),
	B.PRICE,
	B.AKCIZ,
	B.NUM_TD, 
	B.QTY,
	B.SUMMA,
	B.STAVKA_NDS,
	B.SUMMA_NDS,
	B.SUMMA_ALL,
	B.NO_NDS
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] C
	INNER JOIN {Variable_SmetaDb}.dbo.conv_BK_DOC_TABLE_MZ_NDS_FN B ON B.[LINK_UP] = C.[LINK_OLD]
	LEFT JOIN [{Variable_TempDb}].dbo.__DICTIONARY_TMC_SMETA_KS TMC ON B.INV_TYPE {WORK_COLLATE} = 'DICTIONARY_TMC' AND B.INV_LINK = TMC.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.__INVENTORY_SMETA_KS I ON B.INV_TYPE {WORK_COLLATE} = 'INVENTORY_CARD' AND B.INV_LINK = I.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_SMETA_KS N ON (B.INV_TYPE {WORK_COLLATE} = 'BV_NOMENCLATURE' OR B.INV_TYPE {WORK_COLLATE} = 'DICTIONARY_SERV') AND B.INV_LINK = N.LINK_OLD	
WHERE 
	C.[DATE] = @DATE_CONV

OPEN CURS
FETCH FIRST FROM CURS INTO @iLINK_UP, @iINV_TYPE, @iINV_LINK, @nPRICE, @nAKCIZ, @cNUM_TD, @nQTY, @nSUMMA, @nSTAVKA_NDS, @nSUMMA_NDS, @nSUMMA_ALL, @iNO_NDS
WHILE @@FETCH_STATUS=0
BEGIN
    IF @@FETCH_STATUS=0
    BEGIN

        SET @iLINK=0
        EXEC [{Variable_WorkDb}].dbo.X_SAVE_DOC_TABLE_MZ_NDS
            @iLINK			OUTPUT
            ,@iLINK_UP          = @iLINK_UP
            ,@iORDERS           = 0
            ,@iINV_TYPE         = @iINV_TYPE
            ,@iINV_LINK         = @iINV_LINK
            ,@nPRICE            = @nPRICE
            ,@nAKCIZ            = @nAKCIZ
            ,@iCOUNTRY_LINK     = NULL
            ,@cNUM_TD           = @cNUM_TD
            ,@nQTY              = @nQTY
            ,@nSUMMA            = @nSUMMA
            ,@nSTAVKA_NDS       = @nSTAVKA_NDS
            ,@nSUMMA_NDS        = @nSUMMA_NDS
            ,@nSUMMA_ALL        = @nSUMMA_ALL
            ,@iEKR              = NULL
            ,@iFIN_SOURCE       = NULL
            ,@iNO_NDS           = @iNO_NDS
            ,@iTYPE_NDS_LINK    = NULL
            ,@iDOP_CLASSIF_LINK = NULL
            ,@iKAU_LINK         = NULL
            ,@iKL_KBK_LINK      = NULL
            ,@iKL_REG_LINK      = NULL
            ,@nSTAVKA_NDS_AVANSE= 0

			SELECT @iError = @@ERROR
			IF @iError <> 0
			BEGIN
				ROLLBACK
			END            

			EXEC dbo.[X_UPDATE_OUT_TABLE_MZ_INCOME]
				@iLINK OUTPUT
				,@iDOC_LINK = @iLINK_UP
				,@iLINK_UP = @iLINK

			SELECT @iError = @@ERROR
			IF @iError <> 0
			BEGIN
				ROLLBACK
			END				
				
        FETCH NEXT FROM CURS INTO @iLINK_UP, @iINV_TYPE, @iINV_LINK, @nPRICE, @nAKCIZ, @cNUM_TD, @nQTY, @nSUMMA, @nSTAVKA_NDS, @nSUMMA_NDS, @nSUMMA_ALL, @iNO_NDS

    END
END
CLOSE CURS
DEALLOCATE CURS

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "- "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)


GO


GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO
