
--  
set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__CREDIT_TYPES_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__CREDIT_TYPES_SMETA_KS] (
	[LINK_NEW] INT ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__CREDIT_TYPES_SMETA_KS]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DICTION'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DICTION DROP COLUMN LINK_OLD
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DICTION ADD LINK_OLD INT NULL
GO

INSERT INTO [{Variable_WorkDb}].[dbo].DICTION (CODE, [NAME], [OBJECT], LINK_DEP, [LINK_OLD])
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD INTO [{Variable_TempDb}].dbo.__CREDIT_TYPES_SMETA_KS
SELECT distinct
	CODE        = RIGHT(LTRIM(RTRIM(T.CODE)),20), 
	[NAME]      = RIGHT(LTRIM(RTRIM(T.NAME)),254), 
	[OBJECT]	= [{Variable_WorkDb}].dbo.OBJ_ID('CREDIT_TYPES'),
	LINK_DEP    = {LINK_DEP_MAIN}, 
	[LINK_OLD]  = T.LINK
FROM 
	{Variable_SmetaDb}.dbo.CREDIT_TYPES T

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DICTION DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN
GO

/**********************************************************************/
--  
set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__CREDIT_STAVKI_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__CREDIT_STAVKI_SMETA_KS] (
	[LINK_NEW] INT ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__CREDIT_STAVKI_SMETA_KS]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].CREDIT_STAVKI'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].CREDIT_STAVKI DROP COLUMN LINK_OLD
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].CREDIT_STAVKI ADD LINK_OLD INT NULL
GO

INSERT INTO [{Variable_WorkDb}].[dbo].CREDIT_STAVKI (CODE, [NAME], LINK_DEP, [LINK_OLD])
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD INTO [{Variable_TempDb}].dbo.__CREDIT_STAVKI_SMETA_KS
SELECT distinct
	CODE        = RIGHT(LTRIM(RTRIM(T.CODE)),10), 
	[NAME]      = RIGHT(LTRIM(RTRIM(T.NAME)),254), 
	LINK_DEP    = {LINK_DEP_MAIN},
	[LINK_OLD]  = T.LINK
FROM 
	{Variable_SmetaDb}.dbo.CREDIT_STAVKI T


INSERT INTO [{Variable_WorkDb}].[dbo].CREDIT_STAVKI_SUM ([LINK_UP],[DATE_B],[STAVKA])
SELECT
	A.[LINK_NEW], T.[DATE_B], T.[STAVKA]
FROM
	[{Variable_TempDb}].dbo.__CREDIT_STAVKI_SMETA_KS A
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_STAVKI_SUM T ON A.[LINK_OLD] = T.LINK_UP

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].CREDIT_STAVKI DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN
GO

/*
-- -\\\ 
--  
*/

set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_CREDIT_OUT]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_CREDIT_OUT] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_CREDIT_OUT]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_CREDIT_OUT] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_CREDIT_OUT] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[G_PROV]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW]'), 'Ref', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [Ref]
 	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [Ref] UNIQUEIDENTIFIER
GO

IF OBJECT_ID('TEMPDB..#PARAM','U') IS NOT NULL
	DROP TABLE #PARAM
GO
CREATE TABLE #PARAM (REF UNIQUEIDENTIFIER, LINK_NEW_DOC INT, LINK_OPER INT, VALUE VARCHAR(254), [DATE] DATETIME, LINK_KBK INT)
GO

IF OBJECT_ID('TEMPDB..#SUM','U') IS NOT NULL
	DROP TABLE #SUM
GO
CREATE TABLE #SUM (REF UNIQUEIDENTIFIER, LINK_NEW_DOC INT, LINK_OPER INT, [SUMMA] NUMERIC(18,2), [DATE] DATETIME, [TITLE] VARCHAR(254))
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'CREDIT_OUT'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = '20010101'
SET @DATE_CONV = GETDATE()

--   ,    	
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC,LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_CREDIT_OUT]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = G.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'BB_CREDIT'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[CREDIT] 
	(
	[LINK],
	[ACC],
	[OSNOV],
	[TYPE],
	[ACCOUNT],
	[DATE_END],
	[REST]
	)
SELECT 
	[LINK] = C.LINK_NEW,
	[ACC] = ACC.LINK_NEW,
	[OSNOV] = '',
	[TYPE] = T.LINK_NEW,
	[ACCOUNT] = A.LINK,
	[DATE_END] = CH.DATE_END,
	[REST] = CH.REST
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] C
	LEFT JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
		LEFT JOIN {Variable_SmetaDb}.dbo.conv_CREDIT CH ON H.LINK = CH.LINK	
		
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] ACC ON H.ACC = ACC.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__CREDIT_TYPES_SMETA_KS] T ON H.[TYPE] = T.LINK_OLD
	LEFT JOIN (
		select O.LINK_G_PROV, SA2.LINK, NUM = ROW_NUMBER() OVER (PARTITION BY O.LINK_G_PROV ORDER BY SA2.LINK) 
		from 
			{Variable_SmetaDb}.dbo.G_PROV_AP GAP
			inner join {Variable_SmetaDb}.dbo.S_ACCOUNTS SA on SA.LINK = GAP.ACCOUNT and (SA.cSinth {WORK_COLLATE} = '301' or SA.cSinth {WORK_COLLATE} = '207')
			inner join {Variable_SmetaDb}.dbo.osnov o ON o.link = GAP.AP1
			LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {LINK_DEP_MAIN} AND sa2.CODE = SA.CODE {WORK_COLLATE}
		) A ON A.LINK_G_PROV = C.LINK_OLD AND A.NUM = 1
WHERE 
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
    ROLLBACK
END


---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, BUYER_LINK)
SELECT 
	LINK_UP         = C.LINK_NEW, 
	BUYER_LINK      = BUYER.LINK_NEW
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] C
	LEFT JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = H.DEP -- 
WHERE 
	C.[DATE] = @DATE_CONV	

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
    ROLLBACK
END


INSERT INTO #PARAM (REF,LINK_NEW_DOC, LINK_OPER, VALUE, [DATE], LINK_KBK)	
SELECT
	REF = NEWID(),
	C.LINK_NEW, 
	O.LINK,
	VALUE = CASE WHEN O.CODE LIKE 'SUM%' OR O.CODE IN ('PARAM_COUNT_PLAT','PARAM_CREDIT_PROC','PARAM_PERIOD_MONTH') THEN P.VALUE {WORK_COLLATE} ELSE '' END,
	[DATE] = CASE WHEN O.CODE LIKE 'PARAM%' THEN P.DATE_B ELSE NULL END,
	LINK_KBK = NULL
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM P ON P.LINK_UP = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM_DICTION PD ON P.PARAM_LINK = PD.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON LTRIM(RTRIM(PD.CODE {WORK_COLLATE})) = 
		CASE O.CODE
			WHEN 'PARAM_COUNT_PLAT' THEN 'PERIODS'
			WHEN 'PARAM_CREDIT_PROC' THEN 'CREDIT_PROC'
			WHEN 'PARAM_DAY_CREDIT' THEN 'B_DAY_CREDIT'
			WHEN 'PARAM_PERIOD_MONTH' THEN 'PERIOD_MONTH'
			WHEN 'SUM_N_CREDIT' THEN 'N_CREDIT'
			WHEN 'SUM_N_PROC' THEN 'N_PROC'
			WHEN 'SUM_PER_CREDIT' THEN 'PER_CREDIT'
			WHEN 'SUM_UPL_CREDIT' THEN 'UPL_CREDIT'
			WHEN 'SUM_UPL_PROC' THEN 'UPL_PROC'
			WHEN 'SUM_N_CREDIT_SH' THEN 'N_SH_CREDIT' --  ()
			WHEN 'SUM_N_PROC_SH' THEN 'N_SH_PROC' --  ()
			WHEN 'SUM_DOLG' THEN 'S_CREDIT' --   
			WHEN 'SUM_UPL_CREDIT_SH' THEN 'UPL_SH_CREDIT' -- ()
			WHEN 'SUM_UPL_PROC_SH' THEN 'UPL_SH_PROC' -- ()				
		END
WHERE 
	C.[DATE] = @DATE_CONV		

UNION ALL

SELECT
	REF = NEWID(),
	C.LINK_NEW, 	 
	O.LINK,
	VALUE = KBK.CODE,
	[DATE] = NULL,
	LINK_KBK = K.LINK_NEW
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
	INNER JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS K ON K.LINK_OLD = H.KBK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON 1=1
	INNER JOIN [{Variable_WorkDb}].dbo.[KL_KBK] KBK ON KBK.LINK = K.LINK_NEW
WHERE
	O.CODE IN ('PARAM_CREDIT_KBK','PARAM_PROC_KBK') 
	AND
	C.[DATE] = @DATE_CONV


/*
--if @cObjCode = 'CREDIT_OUT'
--	set @iObject = dbo.LINK_CREDIT_OUT_PARAM()
--else
--	set @iObject = dbo.LINK_CREDIT_IN_PARAM()
*/

set @iObject = [{Variable_WorkDb}].dbo.LINK_CREDIT_OUT_PARAM()

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP], [OBJECT], [ORDERS], [REF])
SELECT 
	LINK_NEW_DOC, 
	@iOBJECT, 
	ROW_NUMBER() OVER (PARTITION BY T.LINK_NEW_DOC ORDER BY T.LINK_NEW_DOC),
	T.[REF]
FROM 
	#PARAM T

---	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_VID_OPER] (LINK_UP,VID_OPER)	
SELECT 
	OTR.LINK,
	T.LINK_OPER
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
	 	
---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_STRING] (LINK_UP,[OBJECT],STRING)	
SELECT 
	OTR.LINK,
	@iOBJECT,
	T.VALUE
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(LTRIM(RTRIM(T.VALUE)),'') <> ''

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT] (LINK_ROW,[KBK],[INDATE])	
SELECT 
	OTR.LINK,
	T.[LINK_KBK],
	T.[DATE]
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	[LINK_KBK] IS NOT NULL 
	OR 
	T.[DATE] IS NOT NULL


/*
   
*/


INSERT INTO #SUM (REF, LINK_NEW_DOC, LINK_OPER, [SUMMA], [DATE], [TITLE])	
SELECT 
	REF = NEWID(),
	C.LINK_NEW, 
	O.LINK,
	[SUMMA] = P.[SUMMA],
	[DATE] = P.[DATE],
	[TITLE] = P.[TITLE]
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_OUT] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_SUM P ON P.LINK_UP = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM_DICTION PD ON P.PARAM_LINK = PD.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON LTRIM(RTRIM(PD.CODE {WORK_COLLATE})) = 
		CASE O.CODE
			WHEN 'SUM_N_CREDIT' THEN 'N_CREDIT'
			WHEN 'SUM_N_PROC' THEN 'N_PROC'
			WHEN 'SUM_PER_CREDIT' THEN 'PER_CREDIT'
			WHEN 'SUM_UPL_CREDIT' THEN 'UPL_CREDIT'
			WHEN 'SUM_UPL_PROC' THEN 'UPL_PROC'
			WHEN 'SUM_N_CREDIT_SH' THEN 'N_SH_CREDIT' --  ()
			WHEN 'SUM_N_PROC_SH' THEN 'N_SH_PROC' --  ()
			WHEN 'SUM_DOLG' THEN 'S_CREDIT' --   
			WHEN 'SUM_UPL_CREDIT_SH' THEN 'UPL_SH_CREDIT' -- ()
			WHEN 'SUM_UPL_PROC_SH' THEN 'UPL_SH_PROC' -- ()												
		END
WHERE 
	C.[DATE] = @DATE_CONV		

/*
--if @cObjCode = 'CREDIT_OUT'
--	set @iObject = dbo.link_CREDIT_OUT_SUM()
--else
--	set @iObject = dbo.link_CREDIT_IN_SUM()
*/

set @iObject = [{Variable_WorkDb}].dbo.link_CREDIT_OUT_SUM()	

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP], [OBJECT], [ORDERS], [REF])
SELECT 
	LINK_NEW_DOC, 
	@iOBJECT, 
	ROW_NUMBER() OVER (PARTITION BY T.LINK_NEW_DOC ORDER BY T.LINK_NEW_DOC),
	T.REF
FROM 
	#SUM T

---	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_VID_OPER] (LINK_UP,VID_OPER)	
SELECT 
	OTR.LINK,
	T.LINK_OPER
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_STRING] (LINK_UP,[OBJECT],STRING)	
SELECT 
	OTR.LINK,
	@iOBJECT,
	T.[TITLE]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(LTRIM(RTRIM(T.[TITLE])),'') <> ''

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT] (LINK_ROW,[INDATE])	
SELECT 
	OTR.LINK,
	T.[DATE]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	T.[DATE] IS NOT NULL
	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_SUMMA] ([LINK_UP],[OBJECT],[SUMMA])	
SELECT 
	OTR.LINK,
	@iObject,
	T.[SUMMA]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(T.[SUMMA],0) <> 0


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

GO


GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[G_PROV]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW]'), 'Ref', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [Ref]
 	END
GO

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO


/*
-- -\\\  
--  
*/

-- 
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_CREDIT_IN]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_CREDIT_IN] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_CREDIT_IN]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_CREDIT_IN] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_CREDIT_IN] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[G_PROV]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW]'), 'Ref', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [Ref]
 	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [Ref] UNIQUEIDENTIFIER
GO


IF OBJECT_ID('TEMPDB..#PARAM','U') IS NOT NULL
	DROP TABLE #PARAM
GO
CREATE TABLE #PARAM (REF UNIQUEIDENTIFIER, LINK_NEW_DOC INT, LINK_OPER INT, VALUE VARCHAR(254), [DATE] DATETIME, LINK_KBK INT)
GO

IF OBJECT_ID('TEMPDB..#SUM','U') IS NOT NULL
	DROP TABLE #SUM
GO
CREATE TABLE #SUM (REF UNIQUEIDENTIFIER, LINK_NEW_DOC INT, LINK_OPER INT, [SUMMA] NUMERIC(18,2), [DATE] DATETIME, [TITLE] VARCHAR(254))
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'CREDIT_IN'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = '20010101'--DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    	
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC,LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_CREDIT_IN]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = G.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'BB_P_CREDIT'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---

SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN])

INSERT INTO [{Variable_WorkDb}].[dbo].[CREDIT] 
	(
	[LINK],
	[ACC],
	[OSNOV],
	[TYPE],
	[ACCOUNT],
	[DATE_END],
	[REST]
	)
SELECT 
	[LINK] = C.LINK_NEW,
	[ACC] = ACC.LINK_NEW,
	[OSNOV] = '',
	[TYPE] = T.LINK_NEW,
	[ACCOUNT] = A.LINK,
	[DATE_END] = CH.DATE_END,
	[REST] = CH.REST
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] C
	LEFT JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
		LEFT JOIN {Variable_SmetaDb}.dbo.conv_CREDIT CH ON H.LINK = CH.LINK	
			
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] ACC ON H.ACC = ACC.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__CREDIT_TYPES_SMETA_KS] T ON H.[TYPE] = T.LINK_OLD
	LEFT JOIN (
		select O.LINK_G_PROV, SA2.LINK, NUM = ROW_NUMBER() OVER (PARTITION BY O.LINK_G_PROV ORDER BY SA2.LINK) 
		from 
			{Variable_SmetaDb}.dbo.G_PROV_AP GAP
			inner join {Variable_SmetaDb}.dbo.S_ACCOUNTS SA on SA.LINK = GAP.ACCOUNT and (SA.cSinth {WORK_COLLATE} = '301' or SA.cSinth {WORK_COLLATE} = '207')
			inner join {Variable_SmetaDb}.dbo.osnov o ON o.link = GAP.AP1
			LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {LINK_DEP_MAIN} AND sa2.CODE = SA.CODE {WORK_COLLATE}
		) A ON A.LINK_G_PROV = C.LINK_OLD AND A.NUM = 1
WHERE 
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
    ROLLBACK
END


---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, BUYER_LINK)
SELECT 
	LINK_UP         = C.LINK_NEW, 
	BUYER_LINK      = BUYER.LINK_NEW
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] C
	LEFT JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] BUYER ON BUYER.LINK_OLD = H.DEP -- 
WHERE 
	C.[DATE] = @DATE_CONV	

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
    ROLLBACK
END


INSERT INTO #PARAM (REF,LINK_NEW_DOC, LINK_OPER, VALUE, [DATE], LINK_KBK)	
SELECT
	REF = NEWID(), 
	C.LINK_NEW, 
	O.LINK,
	VALUE = CASE WHEN O.CODE LIKE 'SUM%' OR O.CODE IN ('PARAM_COUNT_PLAT','PARAM_CREDIT_PROC','PARAM_PERIOD_MONTH') THEN P.VALUE {WORK_COLLATE} ELSE '' END,
	[DATE] = CASE WHEN O.CODE LIKE 'PARAM%' THEN P.DATE_B ELSE NULL END,
	LINK_KBK = NULL
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM P ON P.LINK_UP = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM_DICTION PD ON P.PARAM_LINK = PD.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON LTRIM(RTRIM(PD.CODE {WORK_COLLATE})) = 
		CASE O.CODE
			WHEN 'PARAM_COUNT_PLAT' THEN 'PERIODS'
			WHEN 'PARAM_CREDIT_PROC' THEN 'CREDIT_PROC'
			WHEN 'PARAM_DAY_CREDIT' THEN 'B_DAY_CREDIT'
			WHEN 'PARAM_PERIOD_MONTH' THEN 'PERIOD_MONTH'
			WHEN 'SUM_N_CREDIT' THEN 'N_CREDIT'
			WHEN 'SUM_N_PROC' THEN 'N_PROC'
			WHEN 'SUM_PER_CREDIT' THEN 'PER_CREDIT'
			WHEN 'SUM_UPL_CREDIT' THEN 'UPL_CREDIT'
			WHEN 'SUM_UPL_PROC' THEN 'UPL_PROC'
			WHEN 'SUM_N_CREDIT_SH' THEN 'N_SH_CREDIT' --  ()
			WHEN 'SUM_N_PROC_SH' THEN 'N_SH_PROC' --  ()
			WHEN 'SUM_DOLG' THEN 'S_CREDIT' --   
			WHEN 'SUM_UPL_CREDIT_SH' THEN 'UPL_SH_CREDIT' -- ()
			WHEN 'SUM_UPL_PROC_SH' THEN 'UPL_SH_PROC' -- ()				
		END
WHERE 
	C.[DATE] = @DATE_CONV		

UNION ALL

SELECT
	REF = NEWID(), 
	C.LINK_NEW, 
	O.LINK,
	VALUE = KBK.CODE,
	[DATE] = NULL,
	LINK_KBK = K.LINK_NEW
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_HEAD H ON H.LINK = C.LINK_OLD
	INNER JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS K ON K.LINK_OLD = H.KBK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON 1=1
	INNER JOIN [{Variable_WorkDb}].dbo.[KL_KBK] KBK ON KBK.LINK = K.LINK_NEW
WHERE
	O.CODE IN ('PARAM_CREDIT_KBK','PARAM_PROC_KBK') 
	AND
	C.[DATE] = @DATE_CONV


/*
--if @cObjCode = 'CREDIT_OUT'
--	set @iObject = dbo.LINK_CREDIT_OUT_PARAM()
--else
--	set @iObject = dbo.LINK_CREDIT_IN_PARAM()
*/

set @iObject = [{Variable_WorkDb}].dbo.LINK_CREDIT_IN_PARAM()	

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP], [OBJECT], [ORDERS], [REF])
SELECT 
	LINK_NEW_DOC, 
	@iOBJECT, 
	ROW_NUMBER() OVER (PARTITION BY T.LINK_NEW_DOC ORDER BY T.LINK_NEW_DOC),
	T.REF
FROM 
	#PARAM T

---	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_VID_OPER] (LINK_UP,VID_OPER)	
SELECT 
	OTR.LINK,
	T.LINK_OPER
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
	 	
---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_STRING] (LINK_UP,[OBJECT],STRING)	
SELECT 
	OTR.LINK,
	@iOBJECT,
	T.VALUE
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(LTRIM(RTRIM(T.VALUE)),'') <> ''

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT] (LINK_ROW,[KBK],[INDATE])	
SELECT 
	OTR.LINK,
	T.[LINK_KBK],
	T.[DATE]
FROM
	#PARAM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	[LINK_KBK] IS NOT NULL 
	OR 
	T.[DATE] IS NOT NULL

/*
   
*/


INSERT INTO #SUM (REF, LINK_NEW_DOC, LINK_OPER, [SUMMA], [DATE], [TITLE])	
SELECT 
	REF = NEWID(),
	C.LINK_NEW, 
	O.LINK,
	[SUMMA] = P.[SUMMA],
	[DATE] = P.[DATE],
	[TITLE] = P.[TITLE]
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_CREDIT_IN] C
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_SUM P ON P.LINK_UP = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.CREDIT_PARAM_DICTION PD ON P.PARAM_LINK = PD.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.DOC_OPERS O ON LTRIM(RTRIM(PD.CODE {WORK_COLLATE})) = 
		CASE O.CODE
			WHEN 'SUM_N_CREDIT' THEN 'N_CREDIT'
			WHEN 'SUM_N_PROC' THEN 'N_PROC'
			WHEN 'SUM_PER_CREDIT' THEN 'PER_CREDIT'
			WHEN 'SUM_UPL_CREDIT' THEN 'UPL_CREDIT'
			WHEN 'SUM_UPL_PROC' THEN 'UPL_PROC'
			WHEN 'SUM_N_CREDIT_SH' THEN 'N_SH_CREDIT' --  ()
			WHEN 'SUM_N_PROC_SH' THEN 'N_SH_PROC' --  ()
			WHEN 'SUM_DOLG' THEN 'S_CREDIT' --   
			WHEN 'SUM_UPL_CREDIT_SH' THEN 'UPL_SH_CREDIT' -- ()
			WHEN 'SUM_UPL_PROC_SH' THEN 'UPL_SH_PROC' -- ()				
		END
WHERE 
	C.[DATE] = @DATE_CONV		


/*
--if @cObjCode = 'CREDIT_OUT'
--	set @iObject = dbo.link_CREDIT_OUT_SUM()
--else
--	set @iObject = dbo.link_CREDIT_IN_SUM()
*/

set @iObject = [{Variable_WorkDb}].dbo.link_CREDIT_IN_SUM()	

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP], [OBJECT], [ORDERS], [REF])
SELECT 
	LINK_NEW_DOC, 
	@iOBJECT, 
	ROW_NUMBER() OVER (PARTITION BY T.LINK_NEW_DOC ORDER BY T.LINK_NEW_DOC),
	T.REF
FROM 
	#SUM T

---	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_VID_OPER] (LINK_UP,VID_OPER)	
SELECT 
	OTR.LINK,
	T.LINK_OPER
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_STRING] (LINK_UP,[OBJECT],STRING)	
SELECT 
	OTR.LINK,
	@iOBJECT,
	T.[TITLE]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(LTRIM(RTRIM(T.[TITLE])),'') <> ''

---
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT] (LINK_ROW,[INDATE])	
SELECT 
	OTR.LINK,
	T.[DATE]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	T.[DATE] IS NOT NULL
	
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_SUMMA] ([LINK_UP],[OBJECT],[SUMMA])	
SELECT 
	OTR.LINK,
	@iObject,
	T.[SUMMA]
FROM
	#SUM T
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OTR ON OTR.REF = T.REF
WHERE
	ISNULL(T.[SUMMA],0) <> 0


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

GO


GO


IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[G_PROV]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW]'), 'Ref', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [Ref]
 	END
GO

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO

