
--     

set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_BB_UVED_817_69N]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_BB_UVED_817_69N] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_BB_UVED_817_69N]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_BB_UVED_817_69N] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_SMETA_KS_BB_UVED_817_69N] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'BB_UVED_817_69N'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
	(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC,[GUID],LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_BB_UVED_817_69N]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,[GUID]		= G.[GUID]
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_BB_UVED_817_69N] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'BB_UVED_817_69N'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_BB_UVED_817_69N])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[FINANSE_HEAD] 
	([Link], [OSNOV], [CHANGE], [F2], [SUMMA], [DEP_IN_ACC], [DEP_IN_LINK], [DATE_APPROV], [P1], [LINK_BUDGET], [YEAR], [MONTH])

SELECT 
	[Link]			=	C.LINK_NEW,
	[OSNOV]			= NULL, 
	[CHANGE]		= 0, 
	[F2]			= 0, 
	[SUMMA]			= 0, 
	[DEP_IN_ACC]	= NULL, 
	[DEP_IN_LINK]	= TD.LINK_NEW, 
	[DATE_APPROV]	= G.DATE_PROV,
	[P1]			= CONVERT(int, (select gpv.value from {Variable_SmetaDb}.dbo.G_PROV_VALUE gpv 
											where gpv.doc_link=g.link and gpv.object=(select link from {Variable_SmetaDb}.dbo.s_objects where code {WORK_COLLATE}='BB_UVED_817_69N_P1'))),
	[LINK_BUDGET]	= A.BUDG_LINK, 
	[YEAR]			= NULL, 
	[MONTH]			= NULL
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_BB_UVED_817_69N] C ON C.LINK_OLD = G.LINK
	LEFT JOIN {Variable_SmetaDb}.dbo.G_PROV_DEPARTMENT GPD on GPD.DOC_LINK = G.LINK 
		and GPD.[OBJECT] = (select LINK from {Variable_SmetaDb}.dbo.S_OBJECTS where CODE {WORK_COLLATE} = 'BB_UVED_817_69N_PDEP_LINK')	
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] TD ON TD.LINK_OLD = GPD.DEPARTMENT
	LEFT JOIN {Variable_WorkDb}.dbo.DEPARTMENTS PD on PD.LINK = TD.LINK_NEW
	LEFT JOIN {Variable_WorkDb}.dbo.ADMIN_BS A on A.LINK_UP = PD.SUB_DEP
WHERE 
	C.[DATE] = @DATE_CONV   

--

CREATE TABLE #OTR (LINK_OLD INT, LINK_NEW INT)

DECLARE @OBJ INT
SET @OBJ = [{Variable_WorkDb}].dbo.obj_id('BB_UVED_817_69N_TABLE')

-------------------
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP], [OBJECT], [ORDERS], [LINK_OLD])
OUTPUT INSERTED.[LINK_OLD], INSERTED.LINK INTO #OTR (LINK_OLD, LINK_NEW)
SELECT
	[LINK_UP] = C.LINK_NEW
	,[OBJECT]  = @OBJ
	,[ORDERS] = ROW_NUMBER() OVER (PARTITION BY UT.LINK_UP ORDER BY UT.LINK)
	,LINK_OLD = UT.LINK
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_BB_UVED_817_69N] C
	INNER JOIN {Variable_SmetaDb}.dbo.UVED_817_TABLE UT ON UT.LINK_UP = C.LINK_OLD

--------------------
INSERT INTO [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT] ([LINK_ROW],[KBK],[EKR],[AP2],[KBK_KT],[EKR_KT],[AP2_KT])	
SELECT
	[LINK_ROW]	=	T.LINK_NEW
	,[KBK]		=	KK.LINK
	,[EKR]		=	SGU2.LINK
	,[AP2]		=	TDC.LINK_NEW		
	,[KBK_KT]	=	TKBKKT.LINK_NEW
	,[EKR_KT]	=	SGU4.LINK
	,[AP2_KT]	=	TDC2.LINK_NEW
FROM 
	#OTR T
	INNER JOIN {Variable_SmetaDb}.dbo.UVED_817_TABLE UT ON UT.LINK = T.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS K ON K.LINK_OLD = UT.LINK_KBK
	LEFT JOIN [{Variable_WorkDb}].dbo.KL_KBK KK ON KK.LINK = K.LINK_NEW
	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU SGU ON SGU.LINK = UT.LINK_SGU
	LEFT JOIN [{Variable_WorkDb}].[dbo].KOSGU SGU2 ON SGU2.CODE = SGU.CODE {WORK_COLLATE}
	LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_SMETA_KS] TDC ON TDC.LINK_OLD = UT.LINK_DCL
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] TKBKKT ON TKBKKT.LINK_OLD = UT.LINK_KBKP
	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU SGU3 ON SGU3.LINK = UT.LINK_SGUP
	LEFT JOIN [{Variable_WorkDb}].[dbo].KOSGU SGU4 ON SGU4.CODE = SGU3.CODE {WORK_COLLATE}
	LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_SMETA_KS] TDC2 ON TDC2.LINK_OLD = UT.LINK_DCLP

----------------
INSERT INTO [{Variable_WorkDb}].dbo.UVED_817_TABLE ([LINK_UP], [SUMMA_UTV], [SUMMA_PER], [SUMMA_RASH], [SUMMA_POL], [SUMMA_POL1])
SELECT
	[LINK_UP]		=	T.LINK_NEW
	,[SUMMA_UTV]	=	UT.SUMMA_UTV
	,[SUMMA_PER]	=	UT.SUMMA_PER
	,[SUMMA_RASH]	=	UT.SUMMA_RASH
	,[SUMMA_POL]	=	UT.SUMMA_POL
	,[SUMMA_POL1]	=	UT.SUMMA_POL1
FROM 
	#OTR T
	INNER JOIN {Variable_SmetaDb}.dbo.UVED_817_TABLE UT ON UT.LINK = T.LINK_OLD

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "    (69)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO

UPDATE C
SET C.DOC_STATUS = CASE WHEN A.DATE_APPROV IS NULL THEN C.DOC_STATUS & ~4 ELSE C.DOC_STATUS | 4 END
FROM [{Variable_WorkDb}].[dbo].[G_PROV_FIELDS] C
INNER JOIN [{Variable_WorkDb}].[dbo].[FINANSE_HEAD] A ON A.LINK = C.LINK_UP

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO
