
--    
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS_FB_RESULT_FINANS')
CREATE INDEX [IX__G_PROV_SMETA_KS_FB_RESULT_FINANS] ON [dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'FB_RESULT_FINANS'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_RESULT_FINANS]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = G.[DATE]
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = G.COMMENT
	,GET_STORE  = 0
	,DEP        = dsks.LINK_NEW
	,ACC        = accks.LINK_NEW
	,LINK_OLD   = G.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] accks ON accks.LINK_OLD = G.ACC
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_FB_RESULT_FINANS] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'FB_RESULT_FINANS'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
--SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_FB_RESULT_FINANS])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[FINANSE_HEAD]
	([Link],[OSNOV],[CHANGE],[F2],[SUMMA],[DEP_IN_ACC],[DEP_IN_LINK],[DATE_APPROV],[P1],[LINK_BUDGET],[YEAR],[MONTH])

SELECT 
	[Link] = C.LINK_NEW
	,[OSNOV] = gpsks.LINK_NEW
	,[CHANGE] = H.CHANGE
	,[F2] = H.F2
	,[SUMMA] = H.[FSUMMA]
	,[DEP_IN_ACC] = accks.LINK_NEW
	,[DEP_IN_LINK] = dpks.LINK_NEW
	,[DATE_APPROV] = H.[DATE_PROV]
	,[P1] = NULL
	,[LINK_BUFGET] = NULL
	,[YEAR] = H.FYEAR
	,[MONTH] = H.PER_NUM
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_FB_RESULT_FINANS] C
	INNER JOIN {Variable_SmetaDb}.dbo.[FB_RESULT_FINANS] H ON H.[LINK] = C.LINK_OLD
	LEFT JOIN {Variable_SmetaDb}.dbo.OSNOV o ON o.LINK = H.[LINK_OSNOV]
	LEFT JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS) gpsks ON gpsks.LINK_OLD = o.LINK_G_PROV AND gpsks.RowNumber = 1
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dpks ON dpks.LINK_OLD = H.FDEP_LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] accks ON accks.LINK_OLD = H.FACC_LINK
WHERE 
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


INSERT [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_OPER],[COMMENT],[LINK_OLD])
SELECT
	[LINK_UP] = C.[LINK_NEW]
	,[OBJECT] = dbo.[obj_id]('FB_RESULT_FINANS_TABLE')
	,[ORDERS] = 0
	,[LINK_OPER] = NULL
	,[COMMENT] = NULL
	,[LINK_OLD] = F.LINK
FROM
	[{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] C
	INNER JOIN {Variable_SmetaDb}.[dbo].[FINANSE] F ON C.LINK_OLD=F.LINK_UP
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT [{Variable_WorkDb}].[dbo].[OUT_TABLE_ANALIT]
([LINK_ROW],[ACCOUNT],[AP1],[AP2],[AP3],[AP4],[AP5],[AP6],[DEP],[DEP_ACC],[EKR],[EMP],[INDATE],[KAU],[KBK],[PRICE],[SUB],[FIN_SOURCE],[AP2_KT],[EKR_KT],[KBK_KT],[EMP_VED],[SUB_VED])
SELECT
	[LINK_ROW] = O.LINK
	,[ACCOUNT] = NULL
	,[AP1] = NULL
	,[AP2] = DC.LINK_NEW
	,[AP3] = NULL
	,[AP4] = NULL
	,[AP5] = NULL
	,[AP6] = NULL
	,[DEP] = NULL
	,[DEP_ACC] = NULL
	,[EKR] = ekr2.[LINK]
	,[EMP] = NULL
	,[INDATE] = NULL
	,[KAU] = NULL
	,[KBK] = kksks.LINK_NEW
	,[PRICE] = F.ITOG
	,[SUB] = NULL
	,[FIN_SOURCE] = NULL
	,[AP2_KT] = NULL
	,[EKR_KT] = NULL
	,[KBK_KT] = NULL
	,[EMP_VED] = NULL
	,[SUB_VED] = NULL
FROM
	[{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] C
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] O ON C.LINK_NEW=O.LINK_UP
	INNER JOIN {Variable_SmetaDb}.[dbo].[FINANS_TABLE_YEAR] F ON O.[LINK_OLD]=F.[LINK]
	LEFT JOIN [{Variable_TempDb}].[dbo].[__DOP_CLASSIF_SMETA_KS] DC ON F.DOP_CL=DC.LINK_OLD
	LEFT JOIN [{Variable_WorkDb}].[dbo].[KOSGU] ekr2 ON F.[EKR_CODE] {WORK_COLLATE} =ekr2.[CODE]
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = F.VKR
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT [{Variable_WorkDb}].[dbo].[FB_RESULT_FINANS_TABLE]
([LINK_ROW],[SUM_FIN],[SUM_LIM])
SELECT
	[LINK_ROW] = O.LINK
	,[SUM_FIN] = F.ITOG
	,[SUM_LIM] = -F.ITOG
FROM
	[{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS] C
	INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] O ON C.LINK_NEW=O.LINK_UP
	INNER JOIN {Variable_SmetaDb}.[dbo].[FINANS_TABLE_YEAR] F ON O.[LINK_OLD]=F.[LINK]
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "   "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN
GO