
-- 
set xact_abort on
BEGIN TRAN
--   

USE [{Variable_WorkDb}]


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]
GO


USE {Variable_TempDb}
GO

-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY] ADD [DATE] datetime
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS_DOCUMENTS_PAY')
CREATE INDEX [IX__G_PROV_SMETA_KS_DOCUMENTS_PAY] ON [dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY] (LINK_OLD)-- ON [INDEX]
GO

USE [{Variable_WorkDb}]
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

DECLARE @iOBJECT INT, @iError INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'DOCUMENTS_PAY'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME, @iROWCOUNT INT
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY]

---
SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = G.[DATE]
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = G.SUMMA
	,COMMENT    = G.COMMENT
	,GET_STORE  = 0
	,DEP        = dsks.LINK_NEW
	,ACC        = accks.LINK_NEW
	,LINK_OLD   = G.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] accks ON accks.LINK_OLD = G.ACC
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY] T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'DOCUMENTS_PAY'

---
SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
BEGIN
    ROLLBACK
END

---
--SET @DATE_CONV = (SELECT MAX(DATE) FROM [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED])

---
INSERT INTO [{Variable_WorkDb}].[dbo].[FINANSE_PAYS]
([Link],[kind],[S_Acc],[D_Acc],[srok],[order_pay],[PAYKIND],[REASON],[TARGETTEXT],[BK_IN_TGT],[PRINT_KPP],[NDS],[NDS_LINK],[Link_Dohod],[Link_SGU],[OKATO],
[P_Reason],[P_Type],[Nal_Period],[TrebDate],[TrebNum],[ZeroDate],[Filial_Pay],[Filial_Rcp],[INN_OK_Pay],[INN_OK_Rcp],[Kod_FP],[LS_Rcp],[Nm_OK_Pay],[Nm_OK_Rcp],
[Time_Pay],[Link_Dogovor],[Link_Invoice],[BO_NUM],[avanse],[SUMMA_NDS],[SHORT],[STATUS],[NALOG_PAY],[TARGET_LINK],[PAY_PURPOSE],[KBK_KREDIT],[SUMMA_P],
[CODE_DOHOD],[NAME_DOHOD],[UIN_CODE],[EMPL_LINK],[FIELD_SHABLON],[USR_TXT],[KT_ACC])

SELECT
	[Link] = C.[LINK_NEW]
	,[kind] = P.[kind]
	,[S_Acc] = sacc.LINK_NEW
	,[D_Acc] = dacc.LINK_NEW
	,[srok] = P.[srok]
	,[order_pay] = P.[order_pay]
	,[PAYKIND] = P.[PAYKIND]
	,[REASON] = P.[REASON]
	,[TARGETTEXT] = P.[TARGETTEXT]
	,[BK_IN_TGT] = P.[BK_IN_TGT]
	,[PRINT_KPP] = P.[PRINT_KPP]
	,[NDS] = P.[NDS]
	,[NDS_LINK] = nds.LINK_NEW
	,[Link_Dohod] = kksk.LINK_NEW
	,[Link_SGU] = sgu.LINK
	,[OKATO] = P.[OKATO]
	,[P_Reason] = P.[P_Reason]
	,[P_Type] = P.[P_Type]
	,[Nal_Period] = P.[Nal_Period]
	,[TrebDate] = P.[TrebDate]
	,[TrebNum] = P.[TrebNum]
	,[ZeroDate] = P.[ZeroDate]
	,[Filial_Pay] = P.[Filial_Pay]
	,[Filial_Rcp] = P.[Filial_Rcp]
	,[INN_OK_Pay] = P.[INN_OK_Pay]
	,[INN_OK_Rcp] = P.[INN_OK_Rcp]
	,[Kod_FP] = P.[Kod_FP]
	,[LS_Rcp] = P.[LS_Rcp]
	,[Nm_OK_Pay] = P.[Nm_OK_Pay]
	,[Nm_OK_Rcp] = P.[Nm_OK_Rcp]
	,[Time_Pay] = P.[Time_Pay]
	,[Link_Dogovor] = DG.[LINK_NEW]
	,[Link_Invoice] = COALESCE(I1.LINK_NEW, I2.LINK_NEW)
	,[BO_NUM] = P.[BO_NUM]
	,[avanse] = P.[avanse]
	,[SUMMA_NDS] = P.[SUMMA_NDS]
	,[SHORT] = P.[SHORT]
	,[STATUS] = ST.[LINK]
	,[NALOG_PAY] = NULL
	,[TARGET_LINK] = NULL
	,[PAY_PURPOSE] = NULL
	,[KBK_KREDIT] = NULL
	,[SUMMA_P] = ISNULL(GS.SUMMA, G.SUMMA)
	,[CODE_DOHOD] = NULL --   ,   
	,[NAME_DOHOD] = NULL --   ,   
	,[UIN_CODE] = P.[UIN_CODE]
------------------------------------------------
--   [EMPL_LINK]
------------------------------------------------
	,[EMPL_LINK] = NULL
------------------------------------------------
--   [FIELD_SHABLON]
------------------------------------------------
	,[FIELD_SHABLON] = NULL
	,[USR_TXT] = P.[TARGETTEXT]
------------------------------------------------
--   [KT_ACC]
------------------------------------------------
	,[KT_ACC] = NULL
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN {Variable_SmetaDb}.dbo.[FINANSE_PAYS] P ON P.[Link] = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.[G_PROV] G ON P.[Link] = G.[LINK]
		LEFT JOIN {Variable_SmetaDb}.[dbo].[conv_DOCUMENTS_PAY] GS ON GS.LINK = G.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] sacc ON sacc.LINK_OLD = P.S_Acc
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] dacc ON dacc.LINK_OLD = P.D_Acc
	LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS kksk ON kksk.LINK_OLD = P.[Link_Dohod]

	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU sgu1 ON sgu1.LINK = P.Link_SGU
	LEFT JOIN
	(SELECT  RowNumber = row_number () OVER ( PARTITION BY CODE ORDER BY CODE), *
	 FROM [{Variable_WorkDb}].dbo.KOSGU) sgu ON sgu.CODE = sgu1.CODE {WORK_COLLATE} AND sgu.RowNumber = 1

	LEFT JOIN [{Variable_WorkDb}].[dbo].[PAY_STATUS] ST ON P.[Status] {WORK_COLLATE} = ST.[CODE]
	LEFT JOIN [{Variable_TempDb}].[dbo].[__G_PROV_DOGOVOR_SMETA_KS] DG ON P.Link_Dogovor = DG.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_ISSUED] I1 ON P.Link_Invoice = I1.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] I2 ON P.Link_Invoice = I2.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].[dbo].[__NDS_SHABLON_SMETA_KS] nds ON P.NDS_LINK = nds.LINK_OLD
WHERE
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

---   
/*
DECLARE @iDOC_OPER INT
SELECT TOP 1 @iDOC_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'BB_ZKR_TRANS_OTHER' --' '

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT
	LINK_UP     = C.LINK_NEW,
	DOC_OPER   = @iDOC_OPER
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_BB_ZAYAVKA_KR] C
WHERE 
	C.[DATE] = @DATE_CONV

---
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END
*/

DECLARE @iTABLE_OBJ_ID INT
SET @iTABLE_OBJ_ID = dbo.[obj_id]('BB_ZAYAVKA_KR_TABSUM')

INSERT [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_OPER],[COMMENT],[LINK_OLD])
SELECT
	[LINK_UP] = C.[LINK_NEW]
	,[OBJECT] = @iTABLE_OBJ_ID
	,[ORDERS] = 0
	,[LINK_OPER] = NULL
	,[COMMENT] = NULL
	,[LINK_OLD] = T.LINK
FROM
	[{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN {Variable_SmetaDb}.[dbo].[ZAYAVKA_KR_TABLE] T ON C.LINK_OLD=T.LINK_UP
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


INSERT [{Variable_WorkDb}].[dbo].[ZAYAVKA_KR_TABLE]
([LINK_UP],[LINK_KBK],[LINK_SGU],[LINK_DCL],[LINK_KBK_D],[LINK_SGU_D],[LINK_DCL_D],[TARGET],[TITLE],[SUMMA],[VYD_SR],[LINK_DT_ACC],[SOURCE],[LINK_KAU],[DCL_LINK_DBT])
SELECT
	[LINK_UP] = O.LINK
	,[LINK_KBK] = kksk.LINK_NEW
	,[LINK_SGU] = sgu.LINK
	,[LINK_DCL] = DCL.LINK_NEW
	,[LINK_KBK_D] = kkskd.LINK_NEW
	,[LINK_SGU_D] = sgud.LINK
	,[LINK_DCL_D] = DCLD.LINK_NEW
	,[TARGET] = T.[TARGET]
	,[TITLE] = T.[TITLE]
	,[SUMMA] = T.[SUMMA]
	,[VYD_SR] = T.[VYD_SR]
	,[LINK_DT_ACC] = accks.LINK_NEW
	,[SOURCE] = fins.LINK
	,[LINK_KAU] = NULL
	,[DCL_LINK_DBT] = NULL

FROM
	[{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN (SELECT ROW_NUMBER() OVER(PARTITION BY [LINK_OLD] ORDER BY [LINK]) [ORDER],* FROM [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW]) O ON C.LINK_NEW=O.LINK_UP
	INNER JOIN {Variable_SmetaDb}.[dbo].[ZAYAVKA_KR_TABLE] T ON O.[LINK_OLD]=T.[LINK]
	LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS kksk ON kksk.LINK_OLD = T.[LINK_KBK]
	LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_SMETA_KS kkskd ON kkskd.LINK_OLD = T.[LINK_KBK_D]

	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU sgu1 ON sgu1.LINK = T.LINK_SGU
	LEFT JOIN
	(SELECT  RowNumber = row_number () OVER ( PARTITION BY CODE ORDER BY CODE), *
	 FROM [{Variable_WorkDb}].dbo.KOSGU) sgu ON sgu.CODE = sgu1.CODE {WORK_COLLATE} AND sgu.RowNumber = 1

	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU sgu1d ON sgu1d.LINK = T.LINK_SGU_D
	LEFT JOIN
	(SELECT  RowNumber = row_number () OVER ( PARTITION BY CODE ORDER BY CODE), *
	 FROM [{Variable_WorkDb}].dbo.KOSGU) sgud ON sgud.CODE = sgu1d.CODE {WORK_COLLATE} AND sgud.RowNumber = 1

	LEFT JOIN [{Variable_TempDb}].[dbo].[__DOP_CLASSIF_SMETA_KS] DCL ON T.LINK_DCL=DCL.LINK_OLD
	LEFT JOIN [{Variable_TempDb}].[dbo].[__DOP_CLASSIF_SMETA_KS] DCLD ON T.LINK_DCL_D=DCLD.LINK_OLD

	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] accks ON accks.LINK_OLD = T.LINK_DT_ACC

	LEFT JOIN {Variable_SmetaDb}.dbo.FIN_SOURCE fins1 ON fins1.LINK = T.[SOURCE]
	LEFT JOIN
	(SELECT  RowNumber = row_number () OVER ( PARTITION BY CODE ORDER BY CODE), *
	 FROM [{Variable_WorkDb}].dbo.FIN_SOURCE) fins ON fins.CODE = fins1.CODE {WORK_COLLATE} AND fins.RowNumber = 1
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT [{Variable_WorkDb}].[dbo].[ZAYAVKA_KR_OSNOV]
([LINK_UP],[LINK_OSNOV],[OSN],[ISRETURN],[NAMEDOC],[NUMDOC],[DATEDOC],[SUBJECT],[NOT_PRINT],[FIRST_DOC])
SELECT
	[LINK_UP] = C.LINK_NEW
	,[LINK_OSNOV] = gpsks.LINK_NEW
	,[OSN] = T.[OSN]
------------------------------------------------
--   [ISRETURN]
------------------------------------------------
	,[ISRETURN] = 0
	,[NAMEDOC] = LEFT(T.[TYPE], 100) --  
	,[NUMDOC] = T.[NUMBER]
	,[DATEDOC] = T.[DATE]
	,[SUBJECT] = T.[COMMENT]
	,[NOT_PRINT] = 0
	,[FIRST_DOC] = 0
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN {Variable_SmetaDb}.dbo.[BB_ZAYAVKA_KR_OSNOV] T ON T.[LINK_UP] = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.OSNOV o ON o.LINK = T.[LINK_OSNOV]
	INNER JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS) gpsks ON gpsks.LINK_OLD = o.LINK_G_PROV AND gpsks.RowNumber = 1
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END


INSERT [{Variable_WorkDb}].[dbo].[ZAYAVKA_KR_OSNOV]
([LINK_UP],[LINK_OSNOV],[OSN],[ISRETURN],[NAMEDOC],[NUMDOC],[DATEDOC],[SUBJECT],[NOT_PRINT],[FIRST_DOC])
SELECT
	[LINK_UP] = C.LINK_NEW
	,[LINK_OSNOV] = gpsks.LINK_NEW
	,[OSN] =  0
------------------------------------------------
--   [ISRETURN]
------------------------------------------------
	,[ISRETURN] = 0
	,[NAMEDOC] = LEFT(o.[TYPE], 100) --  
	,[NUMDOC] = o.[NUMBER]
	,[DATEDOC] = o.[DATE]
	,[SUBJECT] = o.[INFO]
	,[NOT_PRINT] = 0
	,[FIRST_DOC] = 0
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN {Variable_SmetaDb}.dbo.[FINANSE_PAYS] P ON P.[Link] = C.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.BD_OSNOV o ON o.LINK = P.Link_Dogovor
	INNER JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.__G_PROV_DOGOVOR_SMETA_KS) gpsks ON gpsks.LINK_OLD = o.DOC_LINK AND gpsks.RowNumber = 1
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT [{Variable_WorkDb}].[dbo].[ZAYAVKA_KR_OSNOV]
([LINK_UP],[LINK_OSNOV],[OSN],[ISRETURN],[NAMEDOC],[NUMDOC],[DATEDOC],[SUBJECT],[NOT_PRINT],[FIRST_DOC])
SELECT
	[LINK_UP] = C.LINK_NEW
	,[LINK_OSNOV] = I.LINK_NEW
	,[OSN] =  0
------------------------------------------------
--   [ISRETURN]
------------------------------------------------
	,[ISRETURN] = 0
	,[NAMEDOC] = LEFT(o.[TYPE], 100) --  
	,[NUMDOC] = g.[NUMBER]
	,[DATEDOC] = g.[DATE]
	,[SUBJECT] = COALESCE(LEFT(o.[INFO],254), LEFT(G.COMMENT, 254))
	,[NOT_PRINT] = 0
	,[FIRST_DOC] = 0
FROM
	[{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY] C
	INNER JOIN {Variable_SmetaDb}.dbo.[FINANSE_PAYS] P ON P.[Link] = C.LINK_OLD
	INNER JOIN [{Variable_TempDb}].[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_INVOICE_RECEIVED] I ON P.Link_Invoice = I.LINK_OLD
	INNER JOIN [{Variable_WorkDb}].[dbo].[G_PROV] G ON I.LINK_NEW = G.LINK
	LEFT JOIN {Variable_WorkDb}.dbo.BD_OSNOV o ON o.LINK = G.LINK
WHERE
	C.[DATE] = @DATE_CONV

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN
GO