-- 01. -  
set xact_abort on
BEGIN TRAN

/*
{Variable_TempDb} =	{Variable_TempDb}
{Variable_WorkDb} =	{Variable_WorkDb}
{Variable_SmetaDb} =	{Variable_SmetaDb}
{LINK_DEP_MAIN}	= 296172
*/

--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS]
		(
		[LINK_NEW] int ,
		[LINK_OLD] INT
		)

GO

DELETE T1
FROM [dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].PF_GROUP_SERVICE_REC TTT
	WHERE TTT.LINK = T1.LINK_NEW
	)

GO

--  --
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PF_SERVICE_REC_NOMEN]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__PF_SERVICE_REC_NOMEN]
		(
		[NOMEN] INT,
		[DEP_CB] INT
		)

GO

DELETE T1
FROM [dbo].[__PF_SERVICE_REC_NOMEN] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].NOMENCLATURE TTT
	WHERE TTT.LINK = T1.NOMEN
	)
GO
	
USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[dbo].PF_GROUP_SERVICE_REC'))
   ALTER TABLE [dbo].PF_GROUP_SERVICE_REC DROP COLUMN [LINK_OLD]
GO

ALTER TABLE [dbo].PF_GROUP_SERVICE_REC ADD [LINK_OLD] INT NULL
GO

DECLARE
	@DEP_LINK	INT,
	@DEP_NAME	VARCHAR (254),

	@DATE_BEGIN	DATETIME,
	@DEP_CB	INT,
	
	@NOMEN_CODE	VARCHAR (20),
	@NOMEN	INT,
	
	@GRP_CODE	VARCHAR (7),
	
	@GRP_LINK	INT
	
--SET @DEP_NAME = '   "" .'	

--    --
SELECT 
	@DEP_LINK = LINK
FROM {Variable_SmetaDb}.dbo.DEPARTMENTS
WHERE NAME = @DEP_NAME

-- 1.      --
-- dbo.NOMENCLATURE --
SELECT TOP 1
	@GRP_CODE	=	CODE_GRP,
	@GRP_LINK	=	LINK
FROM dbo.GROUP_ACTIVE
WHERE 
	CODE_GRP = '90000'
	AND LINK_DEP = dbo.GetOwnDepLink ()
	AND [OBJECT] = dbo.OBJ_ID ('NOMENCLATURE_SERVICE')

DECLARE #CURS1 CURSOR LOCAL STATIC 
FOR
	SELECT
		DEP1.LINK_CB
	FROM 
		(
		SELECT
			GR_DEP.DEP_LINK
		FROM {Variable_SmetaDb}.dbo.RP_GROUP_DETY GR_DEP
		GROUP BY
			GR_DEP.DEP_LINK
		) AS T1
	INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_SMETA_KS REF_DEP ON (REF_DEP.LINK_OLD = T1.DEP_LINK)
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP DEP1 ON (DEP1.LINK = REF_DEP.LINK_NEW)
	GROUP BY
		DEP1.LINK_CB
	HAVING NOT EXISTS
		(
		SELECT 1
		FROM {Variable_TempDb}.[dbo].[__PF_SERVICE_REC_NOMEN] TTT
		WHERE TTT.DEP_CB = DEP1.LINK_CB
		)

OPEN #CURS1

FETCH FIRST FROM #CURS1
	INTO
		@DEP_CB

WHILE @@FETCH_STATUS = 0
BEGIN
	EXEC dbo.BV_GET_NOMEN_NEXT_CCODE
		@CodeValue	=	@NOMEN_CODE OUTPUT,
		@CODE_GRP	=	@GRP_CODE,
		@iDEP_LINK	=	@DEP_CB

	EXEC dbo.BV_SAVE_NOMENCLATURE
		@varKSparLINK		=	@NOMEN	OUTPUT,
		@varKSparLINK_GRP	=	@GRP_LINK,
		@varKSparCODE		=	@NOMEN_CODE,
		@varKSparNAME		=	' ',
		@LINK_DEP			= @DEP_CB

	IF @NOMEN IS NOT NULL
		INSERT {Variable_TempDb}.[dbo].[__PF_SERVICE_REC_NOMEN]
			(
			[NOMEN],
			[DEP_CB]
			)
		SELECT
			@NOMEN,
			@DEP_CB	

	FETCH NEXT FROM #CURS1
		INTO
			@DEP_CB
END

CLOSE #CURS1
DEALLOCATE #CURS1

-- 2.    --
-- {Variable_WorkDb}.dbo.PF_GROUP_SERVICE_REC --
SET @DATE_BEGIN = CONVERT (DATETIME, CONVERT (VARCHAR (4), YEAR (GETDATE ())) + '0101', 112)

-- DELETE {Variable_WorkDb}.dbo.PF_GROUP_SERVICE_REC
-- UPDATE PF_GROUP_SERVICE_REC SET NOMEN = 68730

INSERT INTO dbo.PF_GROUP_SERVICE_REC
	(
	CODE, NAME, DEP,
	[TYPE],
	DATE_BEG,
	NOMEN,
	LINK_OLD
	)
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO {Variable_TempDb}.[dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS]
SELECT
	T1.CODE,
	T1.NAME,
	DEP_BS.LINK,
	1,
	@DATE_BEGIN,
	NOMEN.LINK,
	T1.LINK
FROM {Variable_SmetaDb}.dbo.RP_GROUP_DETY T1
INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_SMETA_KS REF_DEP ON (REF_DEP.LINK_OLD = T1.DEP_LINK)
INNER JOIN dbo.DEPARTMENTS DEP_BS ON (DEP_BS.LINK = REF_DEP.LINK_NEW)
INNER JOIN dbo.V_DEP CB ON (CB.LINK = DEP_BS.LINK)

LEFT JOIN {Variable_TempDb}.dbo.[__PF_SERVICE_REC_NOMEN] NOM_REF ON (NOM_REF.DEP_CB = CB.LINK_CB)
LEFT JOIN dbo.NOMENCLATURE NOMEN ON (NOMEN.LINK = NOM_REF.NOMEN)

WHERE
	(
	@DEP_LINK IS NULL
	OR T1.DEP_LINK = @DEP_LINK
	)
	AND NOT EXISTS
		(
		SELECT 1
		FROM {Variable_TempDb}.[dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS] TTT
		WHERE TTT.[LINK_OLD] = T1.LINK
		)

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO {Variable_TempDb}.dbo.[__Journal]
VALUES (' "   ( -)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[dbo].PF_GROUP_SERVICE_REC'))
   ALTER TABLE [dbo].PF_GROUP_SERVICE_REC DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN
