-- 02. - 
SET XACT_ABORT ON
BEGIN TRAN

/*
{Variable_TempDb} =	{Variable_TempDb}
{Variable_WorkDb} =	{Variable_WorkDb}
{Variable_SmetaDb} =	{Variable_SmetaDb}
{LINK_DEP_MAIN}	= 296172
*/

--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEP_CHILD_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__DEP_CHILD_SMETA_KS]
		(
		[LINK_NEW] INT,
		[LINK_OLD] INT
		)

GO

DELETE T1
FROM [dbo].[__DEP_CHILD_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].DEPARTMENTS TTT
	WHERE TTT.LINK = T1.LINK_NEW
	)
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEP_ACC_CHILD_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__DEP_ACC_CHILD_SMETA_KS]
		(
		[LINK_ACC] INT,
		[LINK_SMETA_CHILD] INT
		)
GO

DELETE T1
FROM [dbo].[__DEP_ACC_CHILD_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS TTT
	WHERE TTT.LINK = T1.LINK_ACC
	)

GO

USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[dbo].DEPARTMENTS'))
   ALTER TABLE [dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
GO

ALTER TABLE [dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_CHILD' and Object_ID = Object_ID(N'[dbo].DEPARTMENT_ACCOUNTS'))
   ALTER TABLE [dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [LINK_CHILD]
GO

ALTER TABLE [dbo].DEPARTMENT_ACCOUNTS ADD [LINK_CHILD] INT NULL
GO

-- 1.  --
-- dbo.DEPARTMENTS --
INSERT INTO dbo.DEPARTMENTS 
	(
	CODE,
	NAME,
	FULL_NAME,
	PERS_FNAME,
	PERS_NAME,
	PERS_SECNAME,
	SBK_DOCDATE,
	[TYPE],
	LINK_DEP,
	LINK_OLD
	)
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS]
SELECT
	LTRIM (RTRIM (T2.CODE)) +'_' + CONVERT (VARCHAR (20), T1.LINK),
	T1.FAM + SPACE (1) + T1.IM + SPACE (1) + T1.OTCH,
	T1.FAM + SPACE (1) + T1.IM + SPACE (1) + T1.OTCH,
	T1.FAM,
	T1.IM,
	T1.OTCH,
	T1.DATE_ROJD,
	1,
	[{Variable_WorkDb}].dbo.getOwnDepLink(),
	T1.LINK
FROM 
	(
	SELECT
		FAM	=	RTRIM (LTRIM (ISNULL (TTT.FAM, ''))),
		IM	=	RTRIM (LTRIM (ISNULL (TTT.IM, ''))),
		OTCH	=	RTRIM (LTRIM (ISNULL (TTT.OTCH, ''))),
		TTT.DATE_ROJD,
		TTT.LINK,
		TTT.GROUP_LINK
	FROM {Variable_SmetaDb}.dbo.RP_DETY TTT
	) AS T1
INNER JOIN {Variable_SmetaDb}.dbo.RP_GROUP_DETY T2 ON T2.LINK = T1.GROUP_LINK
INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_SMETA_KS T3 ON T3.[LINK_OLD] = T2.DEP_LINK
WHERE
	NOT EXISTS
		(
		SELECT 1
		FROM {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] TTT
		WHERE TTT.[LINK_OLD] = T1.LINK
		)
--	AND FAM = ''

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO {Variable_TempDb}.dbo.[__Journal]
VALUES (' "  -  ( -)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

-- 2.    --
-- dbo.DEPARTMENT_GROUPS_REF --
INSERT INTO dbo.DEPARTMENT_GROUPS_REF
	(
	DEP_LINK,
	GROUP_LINK
	)
SELECT
	T1.LINK_NEW,
	DEP_GR.LINK
FROM {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] T1
INNER JOIN dbo.DEPARTMENT_GROUPS DEP_GR ON
	(
	DEP_GR.LINK_DEP = dbo.GetOwnDepLink ()
	AND
		(
		DEP_GR.[SYS] = 4
		OR DEP_GR.[SYS] = 15
		)
	)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.DEPARTMENT_GROUPS_REF TTT
	WHERE TTT.DEP_LINK = T1.LINK_NEW
		AND TTT.GROUP_LINK = DEP_GR.LINK
	)

-- 3.  --
-- dbo.DEPARTMENT_ACCOUNTS --
INSERT INTO dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) 
	([CODE],[TYPE],[DEP],[LINK_UP],[ACC],[LINK_CHILD])
OUTPUT 
	INSERTED.LINK, INSERTED.[LINK_CHILD]
	INTO {Variable_TempDb}.[dbo].[__DEP_ACC_CHILD_SMETA_KS]
		([LINK_ACC], [LINK_SMETA_CHILD])
SELECT 
	CODE			= RIGHT(REPLACE (CH_DEP.CODE, '_', '00'), 20), 
	[TYPE]			= 2,
	[DEP]			= DEP.LINK_NEW,
	[LINK_UP]		= CH_DEP.LINK,
	[ACC]			= NULL,
	[LINK_CHILD]	= T1.LINK_OLD
FROM {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] T1
INNER JOIN {Variable_SmetaDb}.dbo.RP_DETY T2 ON (T2.LINK = T1.LINK_OLD)
INNER JOIN {Variable_SmetaDb}.dbo.RP_GROUP_DETY T3 ON T3.LINK = T2.GROUP_LINK
INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] DEP ON DEP.LINK_OLD = T3.DEP_LINK
INNER JOIN dbo.[DEPARTMENTS] CH_DEP ON CH_DEP.LINK = T1.LINK_NEW
WHERE
	NOT EXISTS
		(
		SELECT 1
		FROM {Variable_TempDb}.[dbo].[__DEP_ACC_CHILD_SMETA_KS] TTT
		WHERE TTT.[LINK_SMETA_CHILD] = T1.LINK_OLD
		)

-- 4.   --
-- dbo.PF_SERVICE_REC --
INSERT INTO dbo.PF_SERVICE_REC WITH (ROWLOCK) 
	([COMMENT],[DEP],[DEP_ACC]) 
SELECT
	[COMMENT]		= '', 
	[DEP]			= DEP.LINK_NEW,
	[DEP_ACC]		= T_ACC.LINK_ACC
FROM {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] T1
INNER JOIN {Variable_SmetaDb}.dbo.RP_DETY T2 ON (T2.LINK = T1.LINK_OLD)

INNER JOIN {Variable_SmetaDb}.dbo.RP_GROUP_DETY T3 ON T3.LINK = T2.GROUP_LINK
INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] DEP ON DEP.LINK_OLD = T3.DEP_LINK

INNER JOIN {Variable_TempDb}.[dbo].[__DEP_ACC_CHILD_SMETA_KS] T_ACC ON T_ACC.LINK_SMETA_CHILD = T1.LINK_OLD 
WHERE
	NOT EXISTS
		(
		SELECT 1
		FROM dbo.PF_SERVICE_REC TTT
		WHERE TTT.DEP = DEP.LINK_NEW
			AND TTT.DEP_ACC = T_ACC.LINK_ACC
		)

GO

USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[dbo].DEPARTMENTS'))
   ALTER TABLE [dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_CHILD' and Object_ID = Object_ID(N'[dbo].DEPARTMENT_ACCOUNTS'))
   ALTER TABLE [dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [LINK_CHILD]
GO

COMMIT TRAN

