-- 04. -
SET XACT_ABORT ON
BEGIN TRAN

/*
{Variable_TempDb} =	{Variable_TempDb}
{Variable_WorkDb} =	{Variable_WorkDb}
{Variable_SmetaDb} =	{Variable_SmetaDb}
{LINK_DEP_MAIN}	= 296172
*/

--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_RP_DOG_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__G_PROV_RP_DOG_SMETA_KS]
		(
		[LINK_NEW] INT,
		[LINK_OLD] INT
		)
GO

DELETE T1
FROM [dbo].[__G_PROV_RP_DOG_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].G_PROV TTT
	WHERE TTT.LINK = T1.LINK_NEW
	)
GO

USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[dbo].G_PROV'))
   ALTER TABLE [dbo].G_PROV DROP COLUMN [LINK_OLD]
GO

ALTER TABLE [dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

-- 1.  --
-- dbo.G_PROV --
DECLARE
	@OBJ_DOC	INT

SET @OBJ_DOC	=	dbo.OBJ_ID ('PF_CONTRACT_SERVICE')

INSERT INTO dbo.G_PROV
	(
	NUMBER,
	[DATE],
	[OBJECT],
	DATE_PROV,
	SUMMA,
	COMMENT,
	GET_STORE,
	DEP,
	LINK_OLD
	)
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS]
SELECT
	NUMBER	=	CONVERT (VARCHAR (254), DOC.NUMBER),
	[DATE]	=	DOC.DATE_BEGIN,
	[OBJECT]	=	@OBJ_DOC,
	DATE_PROV	=	NULL,
	SUMMA	=	0,
	COMMENT	=	'',
	GET_STORE	=	0,
	DEP	=	DEP.LINK,
	LINK_OLD	=	DOC.LINK
FROM {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC
INNER JOIN {Variable_TempDb}.dbo.__DEPARTMENTS_SMETA_KS T2 ON (T2.LINK_OLD = DOC.DEP_LINK)
INNER JOIN dbo.DEPARTMENTS DEP ON (DEP.LINK = T2.LINK_NEW)
WHERE
	NOT EXISTS
		(
		SELECT 1
		FROM {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] TTT
		WHERE TTT.[LINK_OLD] = DOC.LINK
		)

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO {Variable_TempDb}.dbo.[__Journal]
VALUES (' "    ( -)"', ' : ' + convert(nvarchar(100), @iROWCOUNT), '', 0)

-- 2.    --
-- dbo.G_PROV_CORR --
INSERT INTO dbo.G_PROV_CORR
	(
	LINK_UP,
	SUPPLIER_LINK,	
	BUYER_LINK
	)	
SELECT
	LINK_UP	=	T1.LINK_NEW,
	SUPPLIER_LINK	=	PAR_DEP.LINK,	-- 
	BUYER_LINK	=	CH_DEP.LINK		-- 
FROM {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] T1 
INNER JOIN {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC ON (DOC.LINK = T1.LINK_OLD)

LEFT JOIN {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] CH_B ON (CH_B.LINK_OLD = DOC.DET_LINK)
LEFT JOIN dbo.DEPARTMENTS CH_DEP ON (CH_DEP.LINK = CH_B.LINK_NEW)

LEFT JOIN {Variable_TempDb}.[dbo].[__DEP_PARENT_SMETA_KS] PAR_B ON (PAR_B.LINK_OLD = DOC.KONTRAGENT_LINK)
LEFT JOIN dbo.DEPARTMENTS PAR_DEP ON (PAR_DEP.LINK = PAR_B.LINK_NEW)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.G_PROV_CORR TTT
	WHERE TTT.LINK_UP = T1.LINK_NEW
	)

-- 3.   --
-- dbo.FINANSE_CONTRACT_HEAD --
INSERT INTO dbo.FINANSE_CONTRACT_HEAD
	(
	LINK_UP,
	CON_PAY,
	DATE_BEGIN,
	DATE_END
	)
SELECT
	T1.LINK_NEW,
	CON_PAY	=	0,
	DATE_BEGIN	=	DOC.DATE_BEGIN,
	DATE_END	=	DOC.DATE_END
FROM {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] T1 
INNER JOIN {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC ON (DOC.LINK = T1.LINK_OLD)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.FINANSE_CONTRACT_HEAD TTT
	WHERE TTT.LINK_UP = T1.LINK_NEW
	)

-- 4.   --
-- dbo.FINANSE_CONTRACT --
INSERT INTO dbo.FINANSE_CONTRACT
	(
	LINK_UP,
--	RECORD_NO,
	NOMEN,
	NOMEN_TYPE,
	
	STAVKA_NDS,
	NO_NDS,
	SUMMA_NDS,
	SUMMA_ALL
	)
SELECT
	G.LINK,
	NOMEN.LINK,
	4,					-- WHEN OBJECT_CODE LIKE 'NOMENCLATURE_SERVICE' THEN 4
	
	0,
	0,
	0,
	0
FROM dbo.G_PROV G
INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] T1 ON (T1.LINK_NEW = G.LINK)
INNER JOIN dbo.V_DEP CB ON (CB.LINK = G.DEP)
INNER JOIN {Variable_TempDb}.dbo.[__PF_SERVICE_REC_NOMEN] T2 ON (T2.DEP_CB = CB.LINK_CB)
INNER JOIN dbo.NOMENCLATURE NOMEN ON (NOMEN.LINK = T2.NOMEN)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.FINANSE_CONTRACT TTT
	WHERE TTT.LINK_UP = G.LINK
		AND TTT.NOMEN = NOMEN.LINK
	)

GO


COMMIT TRAN

