/*
       
    
*/


USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#DOCS','U') IS NOT NULL
	DROP TABLE #DOCS
GO
	
CREATE TABLE #DOCS (LINK_NEW INT, LINK_OLD INT)
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_FB_RESULT_FINANS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_RESULT_FINANS]
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_FINANS_ASSIGN]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FINANS_ASSIGN]
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_FINANS_LIMIT]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FINANS_LIMIT]
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_BB_ZAYAVKA_KR]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_BB_ZAYAVKA_KR]		
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PAY]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PAY]
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_PKO]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_PKO]
GO	

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_DOCUMENTS_RKO]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK_NEW, LINK_OLD)
	SELECT LINK_NEW, LINK_OLD FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_DOCUMENTS_RKO]
GO

CREATE INDEX #TMP_IDX_DOCS_LINK_NEW ON #DOCS (LINK_NEW)
GO
CREATE INDEX #TMP_IDX_DOCS_LINK_OLD ON #DOCS (LINK_OLD)
GO

ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV] DISABLE TRIGGER ALL
ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV1] DISABLE TRIGGER ALL
GO

/*       */
UPDATE G1 SET G1.LINK_UP = D.LINK_NEW
FROM
	#DOCS D
	INNER JOIN {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS] T1 ON D.LINK_OLD = T1.LINK_OLD
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON T1.LINK_NEW = G1.LINK_UP
GO

/*  */
UPDATE GD SET GD.DATE_PROV = G.DATE_PROV
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV GD ON GD.LINK = D.LINK_NEW
	INNER JOIN {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS] T1 ON D.LINK_OLD = T1.LINK_OLD
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON T1.LINK_NEW = G.LINK
GO

/*   ,    */
UPDATE F
SET F.DOC_STATUS = CASE WHEN A.DATE_PROV IS NULL THEN F.DOC_STATUS & ~4 ELSE F.DOC_STATUS | 4 END
FROM #DOCS B INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV] A ON A.LINK = B.LINK_NEW
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] F ON A.LINK = F.LINK_UP
GO

/*   ,    */
UPDATE F
SET F.DOC_STATUS = CASE WHEN A.NUMBER IS NULL OR A.NUMBER = '' THEN F.DOC_STATUS & ~2 ELSE F.DOC_STATUS | 2 END
FROM #DOCS B INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV] A ON A.LINK = B.LINK_NEW   
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] F ON A.LINK = F.LINK_UP
GO

/*   */
UPDATE g
SET g.SUMMA = ISNULL([{Variable_WorkDb}].dbo.CalcDocSumma(G.LINK), G.SUMMA)
FROM
	#DOCS D 
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON G.LINK = D.LINK_NEW
GO

/*      */
UPDATE G SET G.DATE_PROV = NULL
FROM
	#DOCS D
	INNER JOIN {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS] T1 ON D.LINK_OLD = T1.LINK_OLD
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON T1.LINK_NEW = G.LINK
GO

/*   (  ),       */
DELETE {Variable_WorkDb}.dbo.G_PROV
WHERE EXISTS (SELECT * FROM #DOCS D INNER JOIN {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS] T1 ON D.LINK_OLD = T1.LINK_OLD WHERE T1.LINK_NEW = {Variable_WorkDb}.dbo.G_PROV.LINK)
GO

/*    ,     */
DELETE FROM {Variable_WorkDb}.dbo.G_PROV_DOC_OPER 
WHERE EXISTS (SELECT * FROM #DOCS D WHERE D.LINK_NEW = {Variable_WorkDb}.dbo.G_PROV_DOC_OPER.LINK_UP)
GO

/*    */

/*
  :
*/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	LEFT JOIN {Variable_WorkDb}.dbo.KO KO ON KO.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
		CASE 
			--1.  201.34   208   - 
			WHEN SAK.cSinth LIKE '208' THEN 'DOCUMENTS_KO_EMPL' 
			--2.  201.34   210.03 - 
			WHEN SAK.cSinth LIKE '210' AND SAK.cAnalit LIKE '03' THEN 'DOCUMENTS_KO_BANK'
			--3.  201.34   302, 206 -
			WHEN (SAK.cSinth LIKE '302' OR SAK.cSinth LIKE '206') THEN 'DOCUMENTS_KO_DEP'
			--4.  201.34   205  - 
			WHEN SAK.cSinth LIKE '205' AND SAK.cSinth NOT LIKE '_' THEN 'ACCOUNT_INCOME_DOH'
			--5.  201.34   205.  -    (205.)
			WHEN SAK.cSinth LIKE '205' AND SAK.cSinth LIKE '_' THEN 'ACCOUNT_INCOME_AVANCE_POLUCHEN'
			--6.  201.34   209   -     (209)
			WHEN SAK.cSinth LIKE '209' THEN 'DOCUMENTS_KO_NEDOCDACA'
			--7.  201.34       -			
			ELSE 'DOCUMENTS_KO_OTHER'
		END
WHERE
	SO.CODE = 'DOCUMENTS_PKO' AND ISNULL(KO.FOND,0) = 0
	AND
	SAD.cSinth LIKE '201' AND SAD.cAnalit LIKE '34'
) T	
WHERE
	T.NUM = 1
GO

/*
  :
*/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	LEFT JOIN {Variable_WorkDb}.dbo.KO KO ON KO.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
		CASE 
			--1.  201.35   208  - ()
			WHEN SAK.cSinth LIKE '208' THEN 'DOCUMENTS_KO_EMPL_F' 
			--2.  201.35   302 -  ()
			WHEN SAK.cSinth LIKE '302' THEN 'DOCUMENTS_KO_DEP_F' 
			--3.  201.35       - ()		
			ELSE 'DOCUMENTS_KO_OTHER_F'
		END
WHERE
	SO.CODE = 'DOCUMENTS_PKO' AND ISNULL(KO.FOND,0) = 1
	AND
	SAD.cSinth LIKE '201' AND SAD.cAnalit LIKE '35'
) T	
WHERE
	T.NUM = 1
GO

/*
  :
*/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	LEFT JOIN {Variable_WorkDb}.dbo.KO KO ON KO.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
		CASE 
			--1.  210.03   201.34 - 
			WHEN SAD.cSinth LIKE '210' AND SAD.cAnalit LIKE '03' THEN 'DOCUMENTS_KO_BANK' 
			--2.  201.23   201.34 -  /  (201.23)
			WHEN SAD.cSinth LIKE '201' AND SAD.cAnalit LIKE '23' THEN 'DOCUMENTS_KO_KARTA' 
			--3.  205        201.34 -  
			WHEN SAD.cSinth LIKE '205' THEN 'DOCUMENTS_KO_VOZVRAT_DOHOD'
			--4.  304.02   201.34 -   
			WHEN SAD.cSinth LIKE '304' AND SAD.cAnalit LIKE '02' THEN 'DOCUMENTS_KO_DEPONENT' 
			--5.  302.11-13  201.34 -   
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '1[1-3]' THEN 'DOCUMENTS_KO_ZARPLATA' 
			--6.  302.25-26   201.34 -    
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '2[5-6]' THEN 'DOCUMENTS_KO_ZARPLATA_VNESHTAT' 
			--7.  302.62-63   201.34 -  ,   .
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '6[2-3]' THEN 'DOCUMENTS_KO_POSOBIE' 
			--8.  304.03      201.34  -    / (304.03)
			WHEN SAD.cSinth LIKE '304' AND SAD.cAnalit LIKE '03' THEN 'DOCUMENTS_KO_UDERZANIY' 
			--9.  302.21-24,29, 206   201.34 - 
			WHEN (SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '2[1-4,9]') OR SAD.cSinth LIKE '206' THEN 'DOCUMENTS_KO_DEP' 
			--10.  208    201.34  - 
			WHEN SAD.cSinth LIKE '208' THEN 'DOCUMENTS_KO_EMPL' 
			--11.  201.34    - 
			ELSE 'DOCUMENTS_KO_OTHER'
		END
WHERE
	SO.CODE = 'DOCUMENTS_RKO' AND ISNULL(KO.FOND,0) = 0
	AND
	SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '34'
) T	
WHERE
	T.NUM = 1
GO

/*	
  :
*/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	LEFT JOIN {Variable_WorkDb}.dbo.KO KO ON KO.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
		CASE 
			--1.  208    201.35  -  ()
			WHEN SAD.cSinth LIKE '208' THEN 'DOCUMENTS_KO_EMPL_F' 
			ELSE 'DOCUMENTS_KO_OTHER_F'
		END
WHERE
	SO.CODE = 'DOCUMENTS_RKO' AND ISNULL(KO.FOND,0) = 1
	AND
	SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '35'
) T	
WHERE
	T.NUM = 1
GO

/*   ,  */
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
	LEFT JOIN {Variable_WorkDb}.dbo.KOSGU KSGU ON KSGU.LINK = GAPK.SGU
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
		CASE 
			--1.  206.21-26,29   304.05(201.11)  -  
			WHEN SAD.cSinth LIKE '206' AND SAD.cAnalit LIKE '2[1-6,9]' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_ADV_POST'
			--2.  302.21-26,29   304.05(201.11)  -  
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '2[1-6,9]' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_PAY_POST'			
			--3.  304.03   304.05(201.11)  -    /(304.03)
			WHEN SAD.cSinth LIKE '304' AND SAD.cAnalit LIKE '03' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_UDER_ZARP'			
			--4.  302.11-13 304.05(201.11)  -   
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '1[1-3]' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_ZARPLATY'				
			--5.  208   304.05(201.11)  -   
			WHEN SAD.cSinth LIKE '208'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_PODOTCHET'			
			--6.  206.41,51   304.05  -   ()
			WHEN SAD.cSinth LIKE '206' AND SAD.cAnalit LIKE '[4,5]1' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05')
					THEN 'BB_ZKR_PAY_TRANSFER_AVANCE'			
			--7.  302.41,51   304.05  -  
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '[4,5]1' 
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05')
					THEN 'BB_ZKR_PAY_TRANSFER'				
			--8.  303.01-03, 06-13  304.05(201.11)  -  
			WHEN SAD.cSinth LIKE '303' AND (SAD.cAnalit LIKE '0[1-3,6-9]' OR SAD.cAnalit LIKE '1[0-3]')
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_NALOG'			
			--9.  303.04   304.05(201.11)  -  
			WHEN SAD.cSinth LIKE '303' AND SAD.cAnalit LIKE '04'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_NALOG_NDS'			
			--10.  304.04    304.05(201.11)  -  () 
			WHEN SAD.cSinth LIKE '304' AND SAD.cAnalit LIKE '04'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_UCHR'			
			--11.  210.02   201.11  -   (210.02)
			WHEN SAD.cSinth LIKE '210' AND SAD.cAnalit LIKE '02'
					AND SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11'
					THEN 'BB_ZKR_TRANS_DOHOD'			
			--12.  302.62 304.05(201.11)  -   
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '62'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_UDER_RODPLATA'			
			--13.  302.61,63   304.05(201.11)  -  ,   .
			WHEN SAD.cSinth LIKE '302' AND SAD.cAnalit LIKE '6[1,3]'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_POSOBIE'			
			--14.  304.01   304.05(201.11)  -      
			WHEN SAD.cSinth LIKE '304' AND SAD.cAnalit LIKE '01'
					AND (SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' OR SAK.cSinth LIKE '201' AND SAK.cAnalit LIKE '11')
					THEN 'BB_ZKR_TRANS_VREM_RASPOR'			
			--15.  301    304.05(810)  -  
			WHEN SAD.cSinth LIKE '301'
					AND SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' AND ISNULL(KSGU.CODE,'') LIKE '810'
					THEN 'SUM_UPL_CREDIT'				
			--16.  301   304.05 (231-232) -  
			WHEN SAD.cSinth LIKE '301'
					AND SAK.cSinth LIKE '304' AND SAK.cAnalit LIKE '05' AND ISNULL(KSGU.CODE,'') LIKE '23[1-2]'
					THEN 'SUM_UPL_PROC'				
			--    
			ELSE 'BB_ZKR_TRANS_OTHER'
		END
WHERE
	SO.CODE = 'DOCUMENTS_PAY' OR SO.CODE = 'BB_ZAYAVKA_KR'
) T	
WHERE
	T.NUM = 1
	
/**/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE = 'RASPREDELENIE_POLUCH'
WHERE
	SO.CODE = 'FINANS_ASSIGN'
	and
	not exists (select * from {Variable_WorkDb}.dbo.G_PROV_DOC_OPER a where a.LINK_UP = D.LINK_NEW and a.DOC_OPER = DO.LINK)
) T	
WHERE
	T.NUM = 1

/**/
INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
SELECT LINK_NEW, LINK
FROM
(SELECT DISTINCT D.LINK_NEW, DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK_NEW ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK_NEW = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE = 'RASPREDELENIE_POLUCH'
WHERE
	SO.CODE = 'FINANS_LIMIT'
	and
	not exists (select * from {Variable_WorkDb}.dbo.G_PROV_DOC_OPER a where a.LINK_UP = D.LINK_NEW and a.DOC_OPER = DO.LINK)
) T	
WHERE
	T.NUM = 1

--SELECT * FROM {Variable_WorkDb}.dbo.V_DOC_OPERS WHERE OBJ_CODE = 'FINANS_LIMIT' ORDER BY NAME
  
ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV] ENABLE TRIGGER ALL
ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV1] ENABLE TRIGGER ALL
GO

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]
GO


/*        .     .
        ().
     ,     "  ".
*/

----  ,     
--IF OBJECT_ID('TEMPDB..#TMP','U') IS NOT NULL
--	DROP TABLE #TMP
--GO

--CREATE TABLE #TMP (LINK_OLD)
--GO

--UPDATE D SET ZB = 1
--OUTPUT UPDATE.LINK INTO #TMP
--FROM
--	{Variable_SmetaDb}.dbo.DEPARTMENTS D
--WHERE
--	[TYPE] <> 4 AND ZB = 0
--	AND
--	EXISTS (
--		SELECT T.LINK_OLD
--		FROM
--			[{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T
--			INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON G.LINK = T.LINK_NEW
--			)

----      , , 
-- INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF
--	(DEP_LINK, GROUP_LINK)
-- SELECT 
--	 DEP_LINK      = dsks.LINK_NEW,
--	 GROUP_LINK    = CASE WHEN d.BUH_TYPE = 0 OR d.BUH_TYPE = 2 THEN dg1.LINK
--					 WHEN d.BUH_TYPE = 1 THEN dg2.LINK
--					 WHEN d.BUH_TYPE = 4 THEN dg3.LINK END
-- FROM
--	#TMP T
--	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON T.LINK_OLD = dsks.LINK_OLD
--	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_OLD
--	LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg1 ON dg1.SNAME = ''
--	LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg2 ON dg2.SNAME = ''
--	LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg3 ON dg3.SNAME = ''
-- WHERE 
--	NOT EXISTS (SELECT 1 FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF dgr WHERE dgr.DEP_LINK = dsks.LINK_NEW AND dgr.GROUP_LINK = 
--            CASE WHEN d.BUH_TYPE = 0 OR d.BUH_TYPE = 2 THEN dg1.LINK
--                 WHEN d.BUH_TYPE = 1 THEN dg2.LINK
--                 WHEN d.BUH_TYPE = 4 THEN dg3.LINK END)


--UPDATE D SET [LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
--FROM
--	#TMP T
--	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON T.LINK_OLD = dsks.LINK_OLD
--	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
			
--GO

