-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__TREASURY_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__TREASURY_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__TREASURY_SMETA_KS]
GO


set xact_abort on
BEGIN TRAN


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO



--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
-- LINK -- this column value is auto-generated
	CODE,
	[NAME],
	FULL_NAME,
	INN,
	KPP,
	OKPO,
	KLADR_LINK,
	HOUSE,
	FLAT,
	VED_LINK,
	MAIN_LINK,
	REGCODE,
	OKATO,
	FIN_CODE,
	TOFK_LINK,
	PFNUMBER,
	BUDG,
	BRON,
	PREFIX,
	OGRN,
	IMNS_LINK,
	ORD_HEAD,
	SBK_REGNUM,
	SBK_DOCNUM,
	SBK_DOCDATE,
	SBK_LINK,
	ZB,
	HIGH_LINK,
	PERS_LINK,
	INN_DOP,
	IS_RBS,
	FO_LINK,
	N_ACC_LINK,
	EGRUL,
	CODE_UBP,
	FSS_REG_NUM,
	FSS_KOD_P,
	FSS_KOD_DOP,
	OKOPF,
	OKFS,
	TFOMS_REG_NUM,
	TFOMS_KT,
	EMail,
	FSS_KP_P1,
	FSS_KP_P2,
	FSS_KP_P3,
	CORP,
	UCHR_LINK,
	CODE_TOFK,
	PHONE,
	-- STAMP -- this column value is auto-generated
	[GUID],
	ROW_ID,
	[ACTION],
	[TYPE], [LINK_DEP],
	[LINK_OLD]
) 
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
 	 INTO [{Variable_TempDb}].dbo.[__TREASURY_SMETA_KS]
SELECT 
	CODE          = LTRIM(RTRIM(t.CODE)), 
	[NAME]        = LEFT(LTRIM(RTRIM(t.NAME)),50),
	FULL_NAME     = LEFT(LTRIM(RTRIM(t.FULL_NAME)),254),
	INN           = LEFT(t.INN,13), 
	KPP           = LEFT(t.KPP,9),
	OKPO          = '',
	KLADR_LINK    = NULL,
	HOUSE         = t.HOUSE,
	FLAT          = t.FLAT,
	VED_LINK      = NULL,
	MAIN_LINK     = NULL,
	REGCODE       = '',
	OKATO         = '',
	FIN_CODE      = '',
	TOFK_LINK     = NULL,
	PFNUMBER      = '',
	BUDG          = '',
	BRON          = 0,
	PREFIX        = '',
	OGRN          = '',
	IMNS_LINK     = NULL,
	ORD_HEAD      = '',
	SBK_REGNUM    = NULL,
	SBK_DOCNUM    = '',
	SBK_DOCDATE   = NULL,
	SBK_LINK      = NULL,
	ZB            = NULL,
	HIGH_LINK     = NULL,
	PERS_LINK     = NULL,
	INN_DOP       = '',
	IS_RBS        = 0,
	FO_LINK       = NULL,
	N_ACC_LINK    = NULL,
	EGRUL         = '',
	CODE_UBP      = '',
	FSS_REG_NUM   = '',
	FSS_KOD_P     = '',
	FSS_KOD_DOP   = '',
	OKOPF         = '',
	OKFS          = '',
	TFOMS_REG_NUM = '',
	TFOMS_KT      = '',
	EMail         = '',
	FSS_KP_P1     = NULL,
	FSS_KP_P2     = NULL,
	FSS_KP_P3     = NULL,
	CORP          = '',
	UCHR_LINK     = NULL,
	CODE_TOFK     = isnull(LTRIM(RTRIM(t.CODE)),''),
	PHONE         = '',
	[GUID]        = NULL,
	ROW_ID        = NULL,
	[ACTION]      = NULL,
	[TYPE]        = 0,
	LINK_DEP      = [{Variable_WorkDb}].dbo.getOwnDepLink(), /*  */
	LINK_OLD      = t.LINK
FROM 
	{Variable_SmetaDb}.dbo.TREASURY t
WHERE
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].[dbo].[__TREASURY_SMETA_KS] A WHERE A.LINK_OLD = t.LINK )

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
GO

---
DECLARE @iGROUP_LINK INT, @IERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 7

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) 
	(DEP_LINK, GROUP_LINK) 
SELECT DISTINCT 
	sb.link_NEW, @iGROUP_LINK
FROM 
	[{Variable_TempDb}].dbo.[__TREASURY_SMETA_KS] sb
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link_NEW AND T.GROUP_LINK = @iGROUP_LINK)
	
	
COMMIT TRAN

